-> activity.e - commodity to monitor user activity

OPT PREPROCESS

MODULE 'icon',
       'commodities',
       'amigalib/argarray',
       'other/ecode',
       'devices/inputevent',
       'dos/dos',
       'exec/libraries',
       'exec/ports',
       'libraries/commodities',
       'intuition/intuition',
       'utility/tagitem',
       'gadtools',
       'libraries/gadtools',
       'tools/ctype',
       'workbench/workbench',
       'workbench/startup',
       'exec/tasks',
       'exec/nodes',
       'dos/dosextens',
       'dos/datetime',
       'exec/io',
       'devices/timer',
       'dos/dostags'

ENUM ERR_NONE, ERR_ARGS, ERR_BRKR, ERR_CRCX, ERR_CXERR, ERR_ECODE, ERR_LIB,
     ERR_PORT, ERR_SIG, ERR_MENU, ERR_IO, ERR_DEV

ENUM FIELD_DATE,FIELD_TIME,FIELD_LEFT,FIELD_RIGHT,FIELD_MOVE,FIELD_KEY

CONST EVT_POPUP=1,EVT_QUIT=2

RAISE ERR_BRKR IF CxBroker()=NIL,
      ERR_CRCX IF CreateCxObj()=NIL,
      ERR_LIB  IF OpenLibrary()=NIL,
      ERR_PORT IF CreateMsgPort()=NIL,
      ERR_SIG  IF AllocSignal()=-1,
      ERR_MENU IF LayoutMenusA()=NIL,
      ERR_IO   IF CreateIORequest()=NIL,
      ERR_DEV  IF OpenDevice()<>0

DEF broker_mp=NIL:PTR TO mp, broker=NIL, cocustom=NIL, cosignal=NIL,
    task, cxsigflag, signal=-1, cxobjsignal, wnd=NIL:PTR TO window,
    title[30]:STRING,hotkey:PTR TO CHAR,quitkey:PTR TO CHAR,
    menus=NIL,tformat:PTR TO CHAR,
    topedge,leftedge,savetime,file:PTR TO CHAR,timerMP=NIL:PTR TO mp,
    timerIO=NIL:PTR TO timerequest,timersigflag=0,width

DEF left=0,right=0,move=0,key=0

-> main()
PROC main() HANDLE
  DEF ttypes=NIL, msg, cxfunc
  DEF x,filter
  DEF vis=NIL
  DEF openerr=1
  DEF nb_err
  cxbase:=OpenLibrary('commodities.library', 37)
  -> Open the icon.library for support functions, argXXX()
  iconbase:=OpenLibrary('icon.library', 36)
  ttypes:=argArrayInit()

  gadtoolsbase:=OpenLibrary('gadtools.library',36)
  vis:=GetVisualInfoA(OpenWorkBench(),[NIL])
  IF vis=NIL THEN Raise(ERR_MENU)
  menus:=CreateMenusA(
    [ 1,0,'Project',0,0,0,0,
       2,0,'About','A',0,0,0,
       2,0,'Help','?',0,0,0,
       2,0,-1,0,0,0,0,
       2,0,'Save','S',0,0,0,
       2,0,'Reset','R',0,0,0,
       2,0,-1,0,0,0,0,
       2,0,'Hide','H',0,0,0,
       2,0,'Quit','Q',0,0,0,
      1,0,'Extras',0,0,0,0,
       2,0,'AStats','T',IF argString(ttypes,'FILE',NIL) AND (FileLength('PROGDIR:AStats')>0) THEN 0 ELSE NM_ITEMDISABLED,0,0,
     0,0,NIL,0,0,0,0]:newmenu,
     [NIL])
  IF menus=NIL THEN Raise(ERR_MENU)
  LayoutMenusA(menus,vis,[GTMN_NEWLOOKMENUS,TRUE,NIL])

  broker_mp:=CreateMsgPort()
  cxsigflag:=Shl(1, broker_mp.sigbit)


  broker:=CxBroker([NB_VERSION, 0, 'Activity',
                    'Activity-meter', 'Monitor user activity',
                    NBU_UNIQUE OR NBU_NOTIFY, COF_SHOW_HIDE,
                    argInt(ttypes, 'CX_PRIORITY', 0),
                    0, broker_mp, 0]:newbroker,{nb_err})

  IF NIL=(cxfunc:=eCodeCxCustom({cxFunction})) THEN Raise(ERR_ECODE)
  cocustom:=CxCustom(cxfunc, 0)
  AttachCxObj(broker, cocustom)
  signal:=AllocSignal(-1)
  cxobjsignal:=Shl(1, signal)
  cxsigflag:=cxsigflag OR cxobjsignal
  task:=FindTask(NIL)
  cosignal:=CxSignal(task, signal)
  AttachCxObj(cocustom, cosignal)

  quitkey:=argString(ttypes, 'QUITKEY', 'control lcommand m')
  filter:=CxFilter(quitkey)
  IF CxObjError(filter) THEN Throw(ERR_CXERR,'QUITKEY not OK')
  AttachCxObj(broker, filter)
  x:=CxSender(broker_mp, EVT_QUIT)
  AttachCxObj(filter, x)
  x:=CxTranslate(NIL)
  AttachCxObj(filter, x)

  hotkey:=argString(ttypes, 'CX_POPKEY', 'control alt m')
  filter:=CxFilter(hotkey)
  IF CxObjError(filter) THEN Throw(ERR_CXERR,'CX_POPKEY not OK')
  AttachCxObj(broker, filter)
  x:=CxSender(broker_mp, EVT_POPUP)
  AttachCxObj(filter, x)
  x:=CxTranslate(NIL)
  AttachCxObj(filter, x)

  tformat:=argString(ttypes,'FORMAT','L:%L R:%R K:%K')
  leftedge:=argInt(ttypes,'X',0)
  topedge:=argInt(ttypes,'Y',0)
  width:=argInt(ttypes,'WIDTH',300)

  savetime:=argInt(ttypes,'SAVETIME',0)
  IF savetime<0
    IF EasyRequestArgs(0,[20,0,'Activity Warning','Negative savetime.','Savetime:=\d|Auto-save off']:easystruct,0,[-savetime])
      savetime:=-savetime
    ELSE
      savetime:=0
    ENDIF
  ENDIF
  file:=argString(ttypes,'FILE',NIL)
  IF file=NIL THEN savetime:=0
  loadc()

  IF savetime
    timerMP:=CreateMsgPort()
    timersigflag:=Shl(1,timerMP.sigbit)
    timerIO:=CreateIORequest(timerMP,SIZEOF timerequest)
    openerr:=OpenDevice('timer.device',UNIT_VBLANK,timerIO,0)
    inittimer()
  ENDIF

  ActivateCxObj(broker, TRUE)
  IF CxObjError(filter) THEN Throw(ERR_CXERR,'Broker error')
  IF argBool(ttypes,'CX_POPUP',TRUE) THEN appear()
  processMsg()

EXCEPT DO
  disappear()
  IF savetime
    IF openerr=0
      AbortIO(timerIO)
      WaitIO(timerIO)
      CloseDevice(timerIO)
    ENDIF
    IF timerIO THEN DeleteIORequest(timerIO)
    IF timerMP THEN DeleteMsgPort(timerMP)
  ENDIF
  IF signal<>-1 THEN FreeSignal(signal)
  IF broker THEN DeleteCxObjAll(broker)
  IF broker_mp
    -> Empty the port of all CxMsgs
    WHILE msg:=GetMsg(broker_mp) DO ReplyMsg(msg)
    DeleteMsgPort(broker_mp)
  ENDIF
  IF menus THEN FreeMenus(menus)
  IF vis THEN FreeVisualInfo(vis)
  IF gadtoolsbase THEN CloseLibrary(gadtoolsbase)
  IF ttypes THEN argArrayDone()
  IF iconbase THEN CloseLibrary(iconbase)
  IF cxbase THEN CloseLibrary(cxbase)
  SELECT exception
  CASE ERR_ARGS;  WriteF('Error: Could not parse tooltypes/arguments\n')
  CASE ERR_BRKR;  IF nb_err<>CBERR_DUP THEN WriteF('Error: Could not create broker\n')
  CASE ERR_CRCX;  WriteF('Error: Could not create CX object\n')
  CASE ERR_CXERR; WriteF('Error: CxObj - \s\n',exceptioninfo)
  CASE ERR_ECODE; WriteF('Error: Ran out of memory in eCodeCxCustom()\n')
  CASE ERR_LIB;   WriteF('Error: Could not open commodities.library\n')
  CASE ERR_PORT;  WriteF('Error: Could not create message port\n')
  CASE ERR_SIG;   WriteF('Error: Could not allocate signal\n')
  CASE ERR_MENU;  WriteF('Error: Could not create/layout menus\n')
  CASE ERR_IO;    WriteF('Error: Could not create IO request\n')
  CASE ERR_DEV;   WriteF('Error: Could not open timer.device\n')
  ENDSELECT
ENDPROC

-> inittimer() - send IORequest for timer
PROC inittimer()
  timerIO.io.command:=TR_ADDREQUEST
  timerIO.time.secs:=savetime
  timerIO.time.micro:=0
  SendIO(timerIO)
ENDPROC

-> processMsg() - process messages
PROC processMsg()
  DEF msg:PTR TO intuimessage, sigrcvd, msgid, msgtype, done=FALSE, class, code
  DEF menunumber,item:PTR TO menuitem,command
  REPEAT
    IF wnd=NIL
      sigrcvd:=Wait(SIGBREAKF_CTRL_C OR cxsigflag OR timersigflag)
    ELSE
      sigrcvd:=Wait(SIGBREAKF_CTRL_C OR cxsigflag OR timersigflag OR Shl(1,wnd.userport.sigbit))
      WHILE msg:=GetMsg(wnd.userport)
        class:=msg.class
        code:=msg.code
        ReplyMsg(msg)
        SELECT class
          CASE IDCMP_CLOSEWINDOW
            disappear()
          CASE IDCMP_VANILLAKEY
            SELECT code
              CASE 27
                disappear()
              CASE "Q"
                disappear()
              CASE "q"
                disappear()
              CASE "x"
                done:=TRUE
              CASE "X"
                done:=TRUE
              CASE "h"
                disappear()
              CASE "H"
                disappear()
              CASE "a"
                about()
              CASE "A"
                about()
              CASE "r"
                left:=0;right:=0;move:=0;key:=0
                formattitle(tformat,title)
                SetWindowTitles(wnd,title,-1)
                savec()
              CASE "R"
                left:=0;right:=0;move:=0;key:=0
                formattitle(tformat,title)
                SetWindowTitles(wnd,title,-1)
                savec()
              CASE "s"
                savec()
                saves()
              CASE "S"
                savec()
                saves()
            ENDSELECT
          CASE IDCMP_RAWKEY
            SELECT code
              CASE 95
                help()
            ENDSELECT
          CASE IDCMP_MENUPICK
            menunumber:=code AND $FFFF
            WHILE (menunumber<>MENUNULL)
              item:=ItemAddress(menus,menunumber)
              command:=item.command
              SELECT command
                CASE "A"
                  about()
                CASE "?"
                  help()
                CASE "S"
                  saves()
                  savec()
                CASE "R"
                  left:=0;right:=0;move:=0;key:=0
                  formattitle(tformat,title)
                  SetWindowTitles(wnd,title,-1)
                  savec()
                CASE "H"
                  disappear()
                CASE "Q"
                  done:=TRUE
                CASE "T"
                  run_astats()
              ENDSELECT
              menunumber:=item.nextselect AND $FFFF
              EXIT done
              EXIT wnd=NIL
            ENDWHILE
        ENDSELECT
        EXIT wnd=NIL
      ENDWHILE
    ENDIF

    WHILE msg:=GetMsg(broker_mp)
      msgid:=CxMsgID(msg)
      msgtype:=CxMsgType(msg)
      ReplyMsg(msg)

      SELECT msgtype
        CASE CXM_COMMAND
          SELECT msgid
            CASE CXCMD_DISABLE
              ActivateCxObj(broker, FALSE)
            CASE CXCMD_ENABLE
              ActivateCxObj(broker, TRUE)
            CASE CXCMD_APPEAR
              appear()
            CASE CXCMD_DISAPPEAR
              disappear()
            CASE CXCMD_KILL
              done:=TRUE
            CASE CXCMD_UNIQUE
              appear()
          ENDSELECT
        CASE CXM_IEVENT
          SELECT msgid
            CASE EVT_POPUP; appear()
            CASE EVT_QUIT;  savec(); done:=TRUE
          ENDSELECT
      ENDSELECT
    ENDWHILE

    IF sigrcvd AND SIGBREAKF_CTRL_C THEN done:=TRUE

    -> Check to see if the signal CxObj signalled us.
    IF sigrcvd AND cxobjsignal
      formattitle(tformat,title)
      IF wnd
        SetWindowTitles(wnd,title,-1)
      ENDIF
    ENDIF

    IF timersigflag
      IF GetMsg(timerMP)
        inittimer()
        savec()
      ENDIF
    ENDIF
  UNTIL done
  disappear()
ENDPROC

-> appear() - show interface
PROC appear()
  IF wnd=NIL
    wnd:=OpenWindowTagList(NIL,
    [WA_TITLE,title,WA_SCREENTITLE,'Activity by Jilles Tjoelker',
     WA_WIDTH,width,WA_HEIGHT,11,WA_LEFT,leftedge,WA_TOP,topedge,
     WA_CLOSEGADGET,TRUE,WA_DEPTHGADGET,TRUE,WA_DRAGBAR,TRUE,
     WA_IDCMP,IDCMP_CLOSEWINDOW OR IDCMP_VANILLAKEY OR IDCMP_RAWKEY OR IDCMP_MENUPICK,
     WA_ACTIVATE,TRUE,WA_NEWLOOKMENUS,TRUE,
     TAG_DONE])
     SetMenuStrip(wnd,menus)
  ELSE
    WindowToFront(wnd)
    ActivateWindow(wnd)
  ENDIF
  ScreenToFront(wnd.wscreen)
  formattitle(tformat,title)
  SetWindowTitles(wnd,title,-1)
ENDPROC

-> disappear() - hide interface
PROC disappear()
  IF wnd
    topedge:=wnd.topedge
    leftedge:=wnd.leftedge
    ClearMenuStrip(wnd)
    CloseWindow(wnd)
    wnd:=NIL
  ENDIF
ENDPROC

-> cxFunction() - function for CxCustom object
PROC cxFunction(cxm, co)
  DEF ie:PTR TO inputevent

  ie:=CxMsgData(cxm)

  IF ie.class=IECLASS_RAWMOUSE
    IF ie.code=IECODE_LBUTTON
      left++
      IF wnd THEN DivertCxMsg(cxm, co, co)
    ELSEIF ie.code=IECODE_RBUTTON
      right++
      IF wnd THEN DivertCxMsg(cxm, co, co)
    ELSEIF ie.code=IECODE_NOBUTTON
      move++
->      IF (move AND $FF=0) AND wnd THEN DivertCxMsg(cxm, co, co)
    ENDIF
  ELSEIF ie.class=IECLASS_RAWKEY
    IF ie.code<=95
      key++
      IF wnd THEN DivertCxMsg(cxm, co, co)
    ENDIF
  ENDIF
ENDPROC

-> vers() - version string
PROC vers() IS '$VER: Activity 2.1 (07-Mar-1996)'

-> about() - show about requester
PROC about()
  EasyRequestArgs(wnd,
    [20,0,'About Activity',
    'Activity by Jilles Tjoelker\n\nE-mail: M.Tjoelker@mpn.cp.philips.com\n\nSnailmail:\nJ. Tjoelker\nCraterlaan 6\n5632 AG Eindhoven\nTHE NETHERLANDS\n\nHotkey: \s\n\s',
    'OK']:easystruct,
    0,[hotkey,vers()])
ENDPROC

-> help() - display help requester
PROC help()
  EasyRequestArgs(wnd,
    [20,0,'Activity help',
    'Function: Monitors user activity.\n\nL: Left mouse button \nR: Right mouse button\nK: Keyboard \n\nKeys:\nESC, Q, H - Hide window\nX         - Exit activity\nR         - Reset counters\nA         - About this program\nS         - Save counters & window position\nHELP      - This requester\n\n\s - Popup\n\s - Save & quit',
    'OK']:easystruct,
    0,[hotkey,quitkey])
ENDPROC

-> run_astats() - start AStats program
PROC run_astats()
  DEF in,cmd[256]:STRING,cd
  IF file
    cd:=CurrentDir(GetProgramDir())
    StringF(cmd,'AStats "\s"',file)
    IF in:=Open('CON:////AStats Output/AUTO/WAIT',MODE_OLDFILE)
      IF SystemTagList(cmd,[SYS_ASYNCH,TRUE,SYS_INPUT,in,SYS_OUTPUT,0,0])=-1
        Close(in)
      ENDIF
    ENDIF
    CurrentDir(cd)
  ELSE
    DisplayBeep(NIL)
  ENDIF
ENDPROC

-> argBool() - this argXxx() function is missing
PROC argBool(ttypes,name,val)
  DEF s:PTR TO CHAR
  s:=argString(ttypes,name,NIL)
  IF s
    val:=TRUE
    IF (s[0]="n") OR (s[0]="N")
      val:=FALSE
    ENDIF
  ENDIF
ENDPROC val

-> formattitle() - create the title string
PROC formattitle(fmt:PTR TO CHAR,dest:PTR TO CHAR)
  DEF i,temp[20]:STRING,pct=FALSE,x
  dest[]:=0
  FOR i:=0 TO StrLen(fmt)-1
    IF pct
      x:=toupper(fmt[i])
      SELECT x            -> SELECT only with variable. GRRR!
        CASE "L"
          StringF(temp,'\d',left)
          AstrCopy(dest,temp,256)
          dest:=dest+StrLen(dest)
        CASE "R"
          StringF(temp,'\d',right)
          AstrCopy(dest,temp,256)
          dest:=dest+StrLen(dest)
        CASE "M"
          StringF(temp,'\d',move)
          AstrCopy(dest,temp,256)
          dest:=dest+StrLen(dest)
        CASE "K"
          StringF(temp,'\d',key)
          AstrCopy(dest,temp,256)
          dest:=dest+StrLen(dest)
        DEFAULT
          dest[]:=fmt[i]
          dest++
      ENDSELECT
      pct:=FALSE
    ELSE
      IF fmt[i]="%"
        pct:=TRUE
      ELSE
        dest[]:=fmt[i]
        dest++
      ENDIF
    ENDIF
  ENDFOR
ENDPROC

-> saves() - save settings (X and Y)
PROC saves() HANDLE
  DEF do=NIL:PTR TO diskobject
  DEF tt=NIL:PTR TO LONG,size=0,i=0
  DEF p:PTR TO LONG,temp[20]:STRING,j=0
  DEF xd=0,yd=0 -> X done, Y done
  DEF wbm:PTR TO wbstartup,cd
  DEF do_tt=NIL
  p:=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]  -> Memory allocations

  IF wbmessage
    wbm:=wbmessage
    cd:=CurrentDir(wbm.arglist[0].lock)
    IF do:=GetDiskObject(wbm.arglist[0].name)
      do_tt:=do.tooltypes
      IF do.tooltypes
        WHILE do.tooltypes[size] DO size++
      ELSE
        size:=0
      ENDIF
      tt:=NewR(size+8*4)
      FOR i:=0 TO size+7 DO tt[i]:=NIL
      CopyMem(do.tooltypes,tt,size+1*4)
      FOR i:=0 TO size+6
        IF ((toupper(tt[i][0])="X") AND (tt[i][1]="=")) OR ((xd=0) AND (tt[i]=0))
          tt[i]:=NewR(20)
          p[j]:=tt[i]
          j++
          StringF(temp,'X=\d',IF wnd THEN wnd.leftedge ELSE leftedge)
          AstrCopy(tt[i],temp)
          xd:=-1
        ENDIF
        IF ((toupper(tt[i][0])="Y") AND (tt[i][1]="=")) OR ((yd=0) AND (tt[i]=0))
          tt[i]:=NewR(20)
          p[j]:=tt[i]
          j++
          StringF(temp,'Y=\d',IF wnd THEN wnd.topedge ELSE topedge)
          AstrCopy(tt[i],temp)
          yd:=-1
        ENDIF
      ENDFOR
      do.tooltypes:=tt
      PutDiskObject(wbm.arglist[0].name,do)
      CurrentDir(cd)
    ENDIF
  ELSE
->    EasyRequestArgs(wnd,[20,0,'Activity Error','Can\at save when started from CLI.','OK']:easystruct,0,NIL)
  ENDIF
EXCEPT DO
  FOR i:=0 TO j
    IF p[i] THEN Dispose(p[i])
  ENDFOR
  IF tt THEN Dispose(tt)
  IF do
    do.tooltypes:=do_tt
    FreeDiskObject(do)
  ENDIF
ENDPROC

-> savec() - save counters
PROC savec()
  DEF lock=0,fh=0
  IF file
    tryagain:
    IF lock:=Lock(file,EXCLUSIVE_LOCK)
      IF fh:=OpenFromLock(lock)
        Seek(fh,0,OFFSET_END)
        writec(fh)
        Close(fh)
      ELSE
        UnLock(lock)
      ENDIF
    ELSE
      IF IoErr()=ERROR_OBJECT_NOT_FOUND
        IF fh:=Open(file,MODE_NEWFILE)
          Fputs(fh,'Activity save file\n')
          Fputs(fh,'Do not modify!\n\n')
          Fputs(fh,'DATE       TIME       LEFT     RIGHT    MOVE     KEYS    \n')
          Fputs(fh,'---------- ---------- -------- -------- -------- --------\n')
          writec(fh)
          Close(fh)
        ELSE
          IF EasyRequestArgs(0,[20,0,'Activity Error','Couldn\at create counters file.','Retry|Cancel']:easystruct,0,NIL)
            JUMP tryagain
          ENDIF
        ENDIF
      ELSE
        IF EasyRequestArgs(0,[20,0,'Activity Error','Couldn\at save counters.','Retry|Cancel']:easystruct,0,NIL)
          JUMP tryagain
        ENDIF
      ENDIF
    ENDIF
  ENDIF
ENDPROC

-> writec() - write a record to filehandle fh
PROC writec(fh)
  DEF dt:datetime,date[16]:ARRAY,time[16]:ARRAY
  DateStamp(dt)
  dt.format:=FORMAT_CDN
  dt.flags:=0
  dt.strday:=NIL
  dt.strdate:=date
  dt.strtime:=time
  DateToStr(dt)
  VfPrintf(fh,'\l\s[10];\s[10];\d[8];\d[8];\d[8];\d[8]\r\n',[date,time,left,right,move,key])
ENDPROC

/* FILE FORMAT, EXPECTED BY loadc()
  * The first lines are ignored. Reading starts after the line which starts
    with "--".
  * Fields, semicolon ";" between them.
    1. FIELD_DATE \_ Not used
    2. FIELD_TIME /  by loadc()
    3. FIELD_LEFT \
    4. FIELD_RIGHT \_ Counters
    5. FIELD_MOVE  /
    6. FIELD_KEY  /
  * Lines should not be longer than 79 characters.
*/

-> loadc() - load counters
PROC loadc()
  DEF fh,string[82]:ARRAY,str[80]:ARRAY,rd=FALSE,
    fnr,tmp
  string[0]:=";"
  IF file
    IF fh:=Open(file,MODE_OLDFILE)
      WHILE Fgets(fh,str,80)
        IF rd
          AstrCopy(string+1,str,81)
          fnr:=0
          tmp:=-1
          WHILE (tmp:=InStr(string,';',tmp+1))<>-1
            SELECT fnr
              CASE FIELD_LEFT
                left:=Val(str+tmp)
              CASE FIELD_RIGHT
                right:=Val(str+tmp)
              CASE FIELD_MOVE
                move:=Val(str+tmp)
              CASE FIELD_KEY
                key:=Val(str+tmp)
            ENDSELECT
            fnr++
          ENDWHILE
        ELSE
          IF (str[0]="-") AND (str[1]="-") THEN rd:=TRUE
        ENDIF
      ENDWHILE
      Close(fh)
    ELSE
      IF IoErr()=ERROR_OBJECT_NOT_FOUND THEN savec() -> create a new file
    ENDIF
  ENDIF
ENDPROC
/*EE folds
-1
55 135 59 4 63 137 67 16 71 7 75 21 82 5 86 5 90 13 94 8 98 36 102 55 106 32 110 9 127 32 
EE folds*/
