-> astats.e - Show activity statistics

MODULE 'dos/dos','dos/datetime','dos/rdargs','intuition/intuition',
  'intuition/screens','utility/tagitem','workbench/startup',
  'gadtools','libraries/gadtools'

ENUM FIELD_DATE,FIELD_TIME,FIELD_LEFT,FIELD_RIGHT,FIELD_MOVE,FIELD_KEY

DEF wnd:PTR TO window,file:PTR TO CHAR,names:PTR TO LONG,scr:PTR TO screen
DEF menus=NIL:PTR TO menu
DEF ok=FALSE

DEF left=0,right=0,move=0,key=0

-> main() - get args, and call main0()
PROC main()
  DEF rda:PTR TO rdargs,a[1]:ARRAY OF LONG,out,in
  DEF sm:PTR TO wbstartup,cd,sm_numargs
  names:=['LEFT','RIGHT','MOVE','KEY']
  IF gadtoolsbase:=OpenLibrary('gadtools.library',0)
    menus:=CreateMenusA(
    [1,0,'Stats',0,0,0,0,
      2,0,'Left button','1',0,0,0,
      2,0,'Right button','2',0,0,0,
      2,0,'Mouse movement','3',0,0,0,
      2,0,'Keyboard','4',0,0,0,
      2,0,-1,0,0,0,0,
      2,0,'Quit','Q',0,0,0,
    0,0,NIL,0,0,0,0]:newmenu,
    [0])
  ENDIF
  sm:=wbmessage
  sm_numargs:=IF sm THEN sm.numargs ELSE 0
  IF sm_numargs=1
    WriteF('Please enter file name: ')
  ENDIF
  in:=SelectInput(IF stdin THEN stdin ELSE stdout)
  out:=SelectOutput(stdout)
  a[0]:=NIL
  IF sm_numargs<=1
    IF rda:=ReadArgs('FILE/A',a,NIL)
      file:=a[0]
      main0()
      FreeArgs(rda)
    ELSE
      PrintFault(IoErr(),NIL)
    ENDIF
  ELSE
    IF sm.arglist[1].lock
      cd:=CurrentDir(sm.arglist[1].lock)
      file:=sm.arglist[1].name
      main0()
      CurrentDir(cd)
    ENDIF
  ENDIF
  SelectInput(in)
  SelectOutput(out)
  IF ok
    Close(conout)
    conout:=0
  ENDIF
  IF gadtoolsbase
    IF menus THEN FreeMenus(menus)
    CloseLibrary(gadtoolsbase)
  ENDIF
ENDPROC

-> main0() - main loop
PROC main0()
  DEF class,code,done=FALSE,col,vis,item:PTR TO menuitem,cmd,imsgCode,menunumber
  IF scr:=LockPubScreen(NIL)
    IF wnd:=OpenW(0,0,scr.width,scr.height,IDCMP_CLOSEWINDOW OR IDCMP_VANILLAKEY OR IDCMP_NEWSIZE OR IDCMP_MENUPICK,WFLG_ACTIVATE OR WFLG_CLOSEGADGET OR WFLG_DRAGBAR OR WFLG_DEPTHGADGET OR WFLG_HASZOOM,'AStats',scr,CUSTOMSCREEN,NIL,[WA_ZOOM,[0,11,200,100]:ibox,WA_NEWLOOKMENUS,TRUE,TAG_DONE])
      IF gadtoolsbase
        IF menus
          IF vis:=GetVisualInfoA(scr,[0])
            LayoutMenusA(menus,vis,[GTMN_NEWLOOKMENUS,TRUE,0])
            SetMenuStrip(wnd,menus)
            FreeVisualInfo(vis)
          ENDIF
        ENDIF
      ENDIF
      ok:=TRUE
      ScreenToFront(wnd.wscreen)
      SetAPen(stdrast,1)
      TextF(5,20,'Select an option')
      FOR col:=0 TO 3
        TextF(10,8*col+32,'\d.   \s',col+1,names[col])
      ENDFOR
      col:=-1
      TextF(10,65,'ESC. Quit')
      WHILE Not(done)
        class:=WaitIMessage(wnd)
        imsgCode:=MsgCode()
        SetAPen(stdrast,0)
        IF class=IDCMP_MENUPICK
          menunumber:=imsgCode AND $FFFF
          WHILE (menunumber<>MENUNULL)
            item:=ItemAddress(menus,menunumber)
            cmd:=item.command
            SELECT "R" OF cmd
              CASE "Q"
                done:=TRUE
              CASE "1","2","3","4"
                class:=IDCMP_VANILLAKEY
                imsgCode:=cmd
            ENDSELECT
            menunumber:=item.nextselect AND $FFFF
            EXIT done
            EXIT wnd=NIL
          ENDWHILE
        ENDIF
        IF class<>IDCMP_MENUPICK
          IF (class<>IDCMP_NEWSIZE) OR (col<>-1)
            RectFill(stdrast,4,11,wnd.width-5,wnd.height-3)
          ENDIF
        ENDIF
        SELECT class
          CASE IDCMP_CLOSEWINDOW; done:=TRUE
          CASE IDCMP_VANILLAKEY
            code:=imsgCode
            IF code=27 THEN done:=TRUE
            IF code="Q" THEN done:=TRUE
            IF code="q" THEN done:=TRUE
            code:=code-47
            IF (code>=FIELD_LEFT) AND (code<=FIELD_KEY)
              col:=Mod(code+1,3)+1
              SetAPen(stdrast,col)
              graph(code)
            ENDIF
          CASE IDCMP_NEWSIZE
            IF col<>-1
              SetAPen(stdrast,col)
              graph(code)
            ENDIF
        ENDSELECT
      ENDWHILE
      ClearMenuStrip(wnd)
      CloseWindow(wnd)
    ELSE
      WriteF('Error: couldn\at open window\n')
    ENDIF
    UnlockPubScreen(NIL,scr)
  ENDIF
ENDPROC

-> graph(field) - draw a graph for a field (definitions FIELD_#?)
-> Modified version of loadc() in activity.e
PROC graph(field)
  DEF fh,string[82]:ARRAY,str[80]:ARRAY,rd=FALSE,
    fnr,tmp,date:PTR TO CHAR,time:PTR TO CHAR,dt:datetime,x,xx=-1
  DEF fo[10]:ARRAY OF LONG
  string[0]:=";"
  x:=4
  Move(stdrast,x,wnd.height-3)
  dt.stamp.minute:=-1
  SetWindowTitles(wnd,'Drawing...',-1)
  IF file
    IF fh:=Open(file,MODE_OLDFILE)
      WHILE Fgets(fh,str,80)
        IF rd
          AstrCopy(string+1,str,81)
          fnr:=0
          tmp:=-1
          WHILE (tmp:=InStr(string,';',tmp+1))<>-1
            SELECT fnr
              CASE FIELD_DATE
                date:=str+tmp
                str[tmp+8]:=0
              CASE FIELD_TIME
                time:=str+tmp
                str[tmp+8]:=0
              CASE FIELD_LEFT
                left:=Val(str+tmp)
              CASE FIELD_RIGHT
                right:=Val(str+tmp)
              CASE FIELD_MOVE
                move:=Val(str+tmp)
              CASE FIELD_KEY
                key:=Val(str+tmp)
            ENDSELECT
            fo[fnr]:=str+tmp
            fnr++
          ENDWHILE
          IF dt.stamp.minute<>-1 THEN xx:=dt.stamp.minute
          dt.format:=FORMAT_CDN
          dt.flags:=0
          dt.strday:=NIL
          dt.strdate:=date
          dt.strtime:=time
          IF StrToDate(dt)
            IF xx<>-1
              x:=x+(dt.stamp.minute-xx)
            ENDIF
            SELECT field
              CASE FIELD_LEFT; Draw(stdrast,x,wnd.height-3-(left/50))
              CASE FIELD_RIGHT; Draw(stdrast,x,wnd.height-3-(right/10))
              CASE FIELD_MOVE; Draw(stdrast,x,wnd.height-3-(move/300))
              CASE FIELD_KEY; Draw(stdrast,x,wnd.height-3-(key/100))
            ENDSELECT
          ELSE
            DisplayBeep(NIL)
          ENDIF
        ELSE
          IF (str[0]="-") AND (str[1]="-") THEN rd:=TRUE
        ENDIF
        EXIT x>(wnd.width-2)
      ENDWHILE
      Close(fh)
    ELSE
      DisplayBeep(NIL)
    ENDIF
  ENDIF
  TextF(4,17,names[field-2])
  SetWindowTitles(wnd,'AStats',-1)
ENDPROC
/*EE folds
-1
16 49 20 74 25 66 
EE folds*/
