/** ** *** MakeRev Header *** **
**
**	** StickySelect - Selector program for ScreenSelect. **
**
**	Copyright  1993 Markus Aalto
**
**	Creation date: 27-Jul-93
**
**	------------------------------------------------------------------
**	$Filename: StickySelect.h $
**	$Revision: 1.1 $
**	$Date: 22-Jan-94 $
**
**	$Author: Markus_Aalto $
**	$Comment: None. $
**
*/

#ifndef	STICKYSELECT_H
#define	STICKYSELECT_H	1

#define		INTUI_V36_NAMES_ONLY	1
#define		__USE_SYSBASE			1

#include	"exec/types.h"
#include	"exec/memory.h"
#include	"exec/lists.h"
#include	"exec/nodes.h"
#include 	"exec/semaphores.h"
#include	"intuition/intuition.h"
#include	"libraries/gadtools.h"
#include	"workbench/startup.h"
#include	"clib/macros.h"

#include	"proto/exec.h"
#include	"proto/intuition.h"
#include	"proto/dos.h"
#include	"proto/utility.h"
#include	"proto/icon.h"
#include	"proto/gadtools.h"
#include	"proto/graphics.h"

#include	"string.h"
#include	"stdio.h"

#define	TEMPLATE		"PUBSCREEN/K,LEFT/N/K,TOP/N/K,WIDTH/N/K,HEIGHT/N/K"
#define	ARG_PUBSCREEN	0
#define	ARG_LEFT		1
#define	ARG_TOP			2
#define	ARG_WIDTH		3
#define	ARG_HEIGHT		4
#define	ARG_COUNT		5

#define	MY_IDCMP_FLAGS	(IDCMP_GADGETDOWN|IDCMP_GADGETUP|IDCMP_CLOSEWINDOW|\
						IDCMP_REFRESHWINDOW|LISTVIEWIDCMP)
#define	SEMAPHORE_NAME	"ScreenSelect"

#define	CODE_NEWCLIENT	((ULONG)~0)

typedef struct {
	struct SignalSemaphore ud_semaphore;
	struct List ud_TaskList;		/* List of tasks to notify. */
	struct List ud_NameList;		/* Screen names. */
	struct Task *ud_ScreenSelectTask;
	ULONG ud_ScreenSelectSignal;	/* Signal to set when selection ready. */
	ULONG ud_code;					/* Selection/Newclient field. */
	ULONG ud_extension;
} UpdateDataSemaphore;

typedef struct {
	struct Node su_Node;
	struct Task *su_Task;
	ULONG su_Signal;
} SignalUpdateNode;

#endif
