#define __USE_SYSBASE

#include <proto/exec.h>
#include <proto/commodities.h>

#include <clib/alib_protos.h>

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>

#include "code.h"
#include "yak.h"
#include "hotkey_types.h"
#include "Requesters.h"

#define CATCOMP_NUMBERS
#include "yak_locale_strings.h"




#define END_OPTION { NO_OPT }

#ifdef PREFS

# define OPTION_DESCRIPTION(Type, LocalID, LabelID, ExcludeIDs, ActivateIDs, DisplayID, DefFlag, DefArgStr, DefArgNum) {Type, LocalID, LabelID, ExcludeIDs, ActivateIDs, DisplayID, DefFlag, DefArgStr, DefArgNum}

#elif defined(CONV)

# define OPTION_DESCRIPTION(Type, LocalID, LabelID, ExcludeIDs, ActivateIDs, DisplayID, DefFlag, DefArgStr, DefArgNum) {Type, LocalID, DefFlag, DefArgStr, DefArgNum}

#else

# define OPTION_DESCRIPTION(Type, LocalID, LabelID, ExcludeIDs, ActivateIDs, DisplayID, DefFlag, DefArgStr, DefArgNum) {Type, LocalID}

#endif


OptDescription ChangeScreenHKOption[4] = {
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_NO_SCREEN_CHANGE,        NO_SCREEN_CHANGE_OPT,        HKO_WORKBENCH_TO_FRONT|HKO_DEFAULT_PUBSCR_TO_FRONT, 0, 0, HKO_NO_SCREEN_CHANGE, NULL, 0),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_WORKBENCH_TO_FRONT,      WORKBENCH_TO_FRONT_OPT,      HKO_NO_SCREEN_CHANGE|HKO_DEFAULT_PUBSCR_TO_FRONT,   0, 1, 0,                    NULL, 0),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_DEFAULT_PUBSCR_TO_FRONT, DEFAULT_PUBSCR_TO_FRONT_OPT, HKO_NO_SCREEN_CHANGE|HKO_WORKBENCH_TO_FRONT,        0, 2, 0,                    NULL, 0),
   END_OPTION 
};

OptDescription CommandHKOption[7] = {
   OPTION_DESCRIPTION( TOGGLE_OPT,  HKO_CLI_COMMAND     , CLI_OPT       , HKO_AREXX_COMMAND, HKO_STACK_COMMAND|HKO_PRIORITY_COMMAND, 0, HKO_CLI_COMMAND,      NULL, 0),
   OPTION_DESCRIPTION( TOGGLE_OPT,  HKO_AREXX_COMMAND   , AREXX_OPT     , HKO_CLI_COMMAND,   HKO_AREXX_PORT,                         3, 0,                    NULL, 0),
   OPTION_DESCRIPTION( INTEGER_OPT, HKO_STACK_COMMAND   , STACK_OPT     , 0,                 0,                                      1, HKO_STACK_COMMAND,    NULL, 4000),
   OPTION_DESCRIPTION( INTEGER_OPT, HKO_PRIORITY_COMMAND, PRIORITY_OPT  , 0,                 0,                                      2, HKO_PRIORITY_COMMAND, NULL, 0),
   OPTION_DESCRIPTION( STRING_OPT,  HKO_COMMAND         , COMMAND_OPT   , 0,                 0,                                      5, 0,                    NULL, 0),
   OPTION_DESCRIPTION( STRING_OPT,  HKO_AREXX_PORT      , AREXX_PORT_OPT, 0,                 0,                                      4, HKO_AREXX_PORT,       "AREXX", 0),
   END_OPTION 
};

OptDescription SelectWindowHKOption[5] = {
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_ACTIVE,      ACTIVE_WINDOW_OPT,     HKO_UNDER_MOUSE|HKO_BY_TITLE, 0,           0, HKO_ACTIVE, NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_UNDER_MOUSE, WINDOW_UNDER_MOUSE_OPT,HKO_ACTIVE|HKO_BY_TITLE,      0,           1, 0,          NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_BY_TITLE,    BY_WINDOW_TITLE_OPT,   HKO_ACTIVE|HKO_UNDER_MOUSE,   HKO_PATTERN, 2, 0,          NULL, 0 ),
   OPTION_DESCRIPTION( STRING_OPT, HKO_PATTERN,     PATTERN_OPT,           0,                            0,           3, 0,          NULL, 0 ),
   END_OPTION 
};

OptDescription SelectScreen0HKOption[6] = {
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_FRONTMOST,   FRONTMOST_SCREEN_OPT,  HKO_ACTIVE|HKO_UNDER_MOUSE|HKO_BY_TITLE,    0,           0, HKO_FRONTMOST, NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_ACTIVE,      ACTIVE_SCREEN_OPT,     HKO_FRONTMOST|HKO_UNDER_MOUSE|HKO_BY_TITLE, 0,           1, 0,             NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_UNDER_MOUSE, SCREEN_UNDER_MOUSE_OPT,HKO_FRONTMOST|HKO_ACTIVE|HKO_BY_TITLE,      0,           2, 0,             NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_BY_TITLE,    BY_SCREEN_TITLE_OPT,   HKO_FRONTMOST|HKO_ACTIVE|HKO_UNDER_MOUSE,   HKO_PATTERN, 3, 0,             NULL, 0 ),
   OPTION_DESCRIPTION( STRING_OPT, HKO_PATTERN,     PATTERN_OPT,           0,                                          0,           4, 0,             NULL, 0 ),
   END_OPTION 
};

OptDescription SelectScreen1HKOption[6] = {
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_REARMOST,    REARMOST_SCREEN_OPT,   HKO_ACTIVE|HKO_UNDER_MOUSE|HKO_BY_TITLE,   0,           0, HKO_REARMOST, NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_ACTIVE,      ACTIVE_SCREEN_OPT,     HKO_REARMOST|HKO_UNDER_MOUSE|HKO_BY_TITLE, 0,           1, 0,            NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_UNDER_MOUSE, SCREEN_UNDER_MOUSE_OPT,HKO_REARMOST|HKO_ACTIVE|HKO_BY_TITLE,      0,           2, 0,            NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_BY_TITLE,    BY_SCREEN_TITLE_OPT,   HKO_REARMOST|HKO_ACTIVE|HKO_UNDER_MOUSE,   HKO_PATTERN, 3, 0,            NULL, 0 ),
   OPTION_DESCRIPTION( STRING_OPT, HKO_PATTERN,     PATTERN_OPT,           0,                                         0,           4, 0,            NULL, 0 ),
   END_OPTION 
};


OptDescription ResizeWindowHKOption[4] = {
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_RESIZE_HORIZONTAL,  RESIZE_HORIZONTAL_OPT,  0, 0,                      0, HKO_RESIZE_HORIZONTAL,  NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_RESIZE_VERTICAL,    RESIZE_VERTICAL_OPT,    0, HKO_RESIZE_VISIBLE_BAR, 1, HKO_RESIZE_VERTICAL,    NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_RESIZE_VISIBLE_BAR, VISIBLE_SCREEN_BAR_OPT, 0, 0,                      2, HKO_RESIZE_VISIBLE_BAR, NULL, 0 ),
   END_OPTION 
};

OptDescription MoveWindowHKOption[10] = {
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_NO_VERTICAL_MOVING,     NO_VERTICAL_MOVING_OPT,     HKO_MOVE_TOP|HKO_MOVE_VERTICAL_CENTER|HKO_MOVE_BOTTOM,              HKO_MOVE_VISIBLE_BAR, 0, 0,                    NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_TOP,               MOVE_TOP_OPT,               HKO_NO_VERTICAL_MOVING|HKO_MOVE_VERTICAL_CENTER|HKO_MOVE_BOTTOM,    HKO_MOVE_VISIBLE_BAR, 1, HKO_MOVE_TOP,         NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_VERTICAL_CENTER,   MOVE_VERTICAL_CENTER_OPT,   HKO_NO_VERTICAL_MOVING|HKO_MOVE_TOP|HKO_MOVE_BOTTOM,                0,                    2, 0,                    NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_BOTTOM,            MOVE_BOTTOM_OPT,            HKO_NO_VERTICAL_MOVING|HKO_MOVE_VERTICAL_CENTER|HKO_MOVE_TOP,       0,                    3, 0,                    NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_VISIBLE_BAR,       VISIBLE_SCREEN_BAR_OPT,     0,                                                                  0,                    4, HKO_MOVE_VISIBLE_BAR, NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_NO_HORIZONTAL_MOVING,   NO_HORIZONTAL_MOVING_OPT,   HKO_MOVE_LEFT|HKO_MOVE_HORIZONTAL_CENTER|HKO_MOVE_RIGHT,            0,                    5, 0,                    NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_LEFT,              MOVE_LEFT_OPT,              HKO_NO_HORIZONTAL_MOVING|HKO_MOVE_HORIZONTAL_CENTER|HKO_MOVE_RIGHT, 0,                    6, HKO_MOVE_LEFT,                    NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_HORIZONTAL_CENTER, MOVE_HORIZONTAL_CENTER_OPT, HKO_NO_HORIZONTAL_MOVING|HKO_MOVE_LEFT|HKO_MOVE_RIGHT,              0,                    7, 0,                    NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_RIGHT,             MOVE_RIGHT_OPT,             HKO_NO_HORIZONTAL_MOVING|HKO_MOVE_HORIZONTAL_CENTER|HKO_MOVE_LEFT,  0,                    8, 0,                    NULL, 0 ),
   END_OPTION 
};

OptDescription InsertDateHKOption[2] = {
   OPTION_DESCRIPTION( STRING_OPT, HKO_DATE_FORMAT, DATE_FORMAT_OPT, 0, 0, 0, 0, NULL, 0 ),
   END_OPTION 
};

OptDescription InsertTextHKOption[3] = {
   OPTION_DESCRIPTION( STRING_OPT,  HKO_INSERT_STRING, INSERT_OPT,          0, 0, 0, 0, NULL, 0 ),
   OPTION_DESCRIPTION( INTEGER_OPT, HKO_INSERT_DELAY,  INSERT_DELAY_OPT,    0, 0, 1, HKO_INSERT_DELAY,    NULL, 0 ),
   END_OPTION 
};

OptDescription MenuHKOption[5] = {
   OPTION_DESCRIPTION( INTEGER_OPT, HKO_MENU_NUMBER,    MENU_NUMBER_OPT,    0, 0,                  0, HKO_MENU_NUMBER,    NULL, 0 ),
   OPTION_DESCRIPTION( INTEGER_OPT, HKO_ITEM_NUMBER,    ITEM_NUMBER_OPT,    0, 0,                  1, HKO_ITEM_NUMBER,    NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT,  HKO_SUBITEM,        SUBITEM_OPT    ,    0, HKO_SUBITEM_NUMBER, 2, 0,                  NULL, 0 ),
   OPTION_DESCRIPTION( INTEGER_OPT, HKO_SUBITEM_NUMBER, SUBITEM_NUMBER_OPT, 0, 0,                  3, HKO_SUBITEM_NUMBER, NULL, 0 ),
   END_OPTION 
};

OptDescription CycleWindowsHKOption[6] = {
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_BACK_CYCLE         , Back_Cycle_OPT        , 0, 0,                     0, 0, NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_EXCLUDE_WB_DRAWERS , Exclude_Wb_Drawers_OPT, 0, 0,                     1, 0, NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_BY_WINDOW_TASK_NAME, By_Task_Name_OPT      , 0, HKO_TASK_NAME_PATTERN, 3, 0, NULL, 0 ),
   OPTION_DESCRIPTION( STRING_OPT, HKO_TASK_NAME_PATTERN  , PATTERN_OPT           , 0, 0,                     4, 0, NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_ACTIVATE_ONLY      , ACTIVATE_ONLY_OPT     , 0, 0,                     2, 0, NULL, 0 ),
   END_OPTION 
};

OptDescription MoveScreenHKOption[10] = {
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_NO_VERTICAL_MOVING,     NO_VERTICAL_MOVING_OPT,     HKO_MOVE_TOP|HKO_MOVE_VERTICAL_CENTER|HKO_MOVE_BOTTOM,              0, 0, 0,             NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_TOP,               MOVE_TOP_OPT,               HKO_NO_VERTICAL_MOVING|HKO_MOVE_VERTICAL_CENTER|HKO_MOVE_BOTTOM,    0, 1, HKO_MOVE_TOP,  NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_VERTICAL_CENTER,   MOVE_VERTICAL_CENTER_OPT,   HKO_NO_VERTICAL_MOVING|HKO_MOVE_TOP|HKO_MOVE_BOTTOM,                0, 2, 0,             NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_BOTTOM,            MOVE_BOTTOM_OPT,            HKO_NO_VERTICAL_MOVING|HKO_MOVE_VERTICAL_CENTER|HKO_MOVE_TOP,       0, 3, 0,             NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_NO_HORIZONTAL_MOVING,   NO_HORIZONTAL_MOVING_OPT,   HKO_MOVE_LEFT|HKO_MOVE_HORIZONTAL_CENTER|HKO_MOVE_RIGHT,            0, 4, HKO_MOVE_LEFT, NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_LEFT,              MOVE_LEFT_OPT,              HKO_NO_HORIZONTAL_MOVING|HKO_MOVE_HORIZONTAL_CENTER|HKO_MOVE_RIGHT, 0, 5, 0,             NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_HORIZONTAL_CENTER, MOVE_HORIZONTAL_CENTER_OPT, HKO_NO_HORIZONTAL_MOVING|HKO_MOVE_LEFT|HKO_MOVE_RIGHT,              0, 6, HKO_MOVE_LEFT, NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_RIGHT,             MOVE_RIGHT_OPT,             HKO_NO_HORIZONTAL_MOVING|HKO_MOVE_HORIZONTAL_CENTER|HKO_MOVE_LEFT,  0, 7, 0,             NULL, 0 ),
   OPTION_DESCRIPTION( TOGGLE_OPT, HKO_MOVE_VISIBLE_ACTIVE,    VISIBLE_ACTIVE_WINDOW_OPT,  0,                                                                  0, 8, 0,             NULL, 0 ),
   END_OPTION 
};


#ifdef PREFS

# define OPTION_LIST(Descriptions, LabelID) {Descriptions, LabelID}

#else

# define OPTION_LIST(Descriptions, LabelID) {Descriptions}

#endif



OptsList opt_ExecuteCommand[] = {
   OPTION_LIST(ChangeScreenHKOption, SCREEN_OPT ),
   OPTION_LIST(CommandHKOption,      SPECIFICATION_OPT )
};

OptsList opt_CloseWindow[] = {
   OPTION_LIST(SelectWindowHKOption, SELECT_OPT )
};

OptsList opt_ZipWindow[] = {
   OPTION_LIST(SelectWindowHKOption, SELECT_OPT )
};

OptsList opt_IconifyWindow[] = {
   OPTION_LIST(SelectWindowHKOption, SELECT_OPT )
};

OptsList opt_ShrinkWindow[] = {
   OPTION_LIST(SelectWindowHKOption, SELECT_OPT ),
   OPTION_LIST(ResizeWindowHKOption, RESIZE_WINDOW_OPT )
};

OptsList opt_ExpandWindow[] = {
   OPTION_LIST(SelectWindowHKOption, SELECT_OPT ),
   OPTION_LIST(ResizeWindowHKOption, RESIZE_WINDOW_OPT )
};

OptsList opt_MoveWindow[] = {
   OPTION_LIST(SelectWindowHKOption, SELECT_OPT ),
   OPTION_LIST(MoveWindowHKOption,   MOVE_OPT )
};


OptsList opt_OpenPalette[] = {
   OPTION_LIST(ChangeScreenHKOption, SCREEN_OPT )
};

OptsList opt_CycleWindows[] = {
   OPTION_LIST(SelectScreen0HKOption, SELECT_OPT ),
   OPTION_LIST(CycleWindowsHKOption, SPECIFICATION_OPT )
};

OptsList opt_ScreenToFront[] = {
   OPTION_LIST(SelectScreen1HKOption, SELECT_OPT )
};

OptsList opt_ScreenToBack[] = {
   OPTION_LIST(SelectScreen0HKOption, SELECT_OPT )
};

OptsList opt_MoveScreen[] = {
   OPTION_LIST(SelectScreen0HKOption, SELECT_OPT ),
   OPTION_LIST(MoveScreenHKOption,   MOVE_OPT )
};

OptsList opt_ShowInterface[] = {
   OPTION_LIST(ChangeScreenHKOption, SCREEN_OPT )
};

OptsList opt_InsertDate[] = {
   OPTION_LIST(InsertDateHKOption, SPECIFICATION_OPT )
};

OptsList opt_InsertText[] = {
   OPTION_LIST(InsertTextHKOption, SPECIFICATION_OPT )
};

OptsList opt_MenuShortcut[] = {
   OPTION_LIST(MenuHKOption, SPECIFICATION_OPT )
};


OptsList opt_CurrentScreenAsDefPub[1];   /* No option */
OptsList opt_ActivateWorkbench[1];       /* No option */
OptsList opt_BlankDisplay[1];            /* No option */



/*
 * HotKey Action function prototypes
 */

#if !defined(PREFS) && !defined(CONV)

GLOBAL
void  act_ExecuteCommand(YakHotKey *yhk),        act_CloseWindow(YakHotKey *yhk),
      act_ZipWindow(YakHotKey *yhk),             act_ShrinkWindow(YakHotKey *yhk),
      act_ExpandWindow(YakHotKey *yhk),          act_MoveWindow(YakHotKey *yhk),
      act_CycleWindows(YakHotKey *yhk),          act_OpenPalette(YakHotKey *yhk),
      act_ScreenToFront(YakHotKey *yhk),         act_ScreenToBack(YakHotKey *yhk),
      act_ActivateWorkbench(YakHotKey *yhk),     act_MoveScreen(YakHotKey *yhk),
      act_BlankDisplay(YakHotKey *yhk),          act_InsertText(YakHotKey *yhk),
      act_InsertDate(YakHotKey *yhk),            act_ShowInterface(YakHotKey *yhk),
      act_CurrentScreenAsDefPub(YakHotKey *yhk), act_MenuShortcut(YakHotKey *yhk),
      act_IconifyWindow(YakHotKey *yhk); 
#endif



#if defined (PREFS)

# define HOTKEY_DESCRIPTION(name, nameact, optsnum, helpnode) {EMPTY_MINLIST, nameact, helpnode, optsnum, opt_##name}

#elif defined (CONV)

# define HOTKEY_DESCRIPTION(name, nameact, optsnum, helpnode) {EMPTY_MINLIST, nameact, optsnum, opt_##name}

#else

# define HOTKEY_DESCRIPTION(name, nameact, optsnum, helpnode) {EMPTY_MINLIST, act_##name, optsnum, opt_##name}

#endif


YakHotKeyType yhktypes[NUM_HOTKEY_TYPES] = {
    HOTKEY_DESCRIPTION( ExecuteCommand,        ExecuteCommand_ACT,        2, "Execute Command" ),
    HOTKEY_DESCRIPTION( CloseWindow,           CloseWindow_ACT,           1, "Close Window" ),
    HOTKEY_DESCRIPTION( ZipWindow,             ZipWindow_ACT,             1, "Zip Window" ),
    HOTKEY_DESCRIPTION( ShrinkWindow,          ShrinkWindow_ACT,          2, "Shrink Window" ),
    HOTKEY_DESCRIPTION( ExpandWindow,          ExpandWindow_ACT,          2, "Expand Window" ),
    HOTKEY_DESCRIPTION( MoveWindow,            MoveWindow_ACT,            2, "Move Window" ),
    HOTKEY_DESCRIPTION( CycleWindows,          CycleWindows_ACT,          2, "Cycle Windows" ),
    HOTKEY_DESCRIPTION( OpenPalette,           OpenPalette_ACT,           1, "Open Palette" ),
    HOTKEY_DESCRIPTION( ScreenToFront,         ScreenToFront_ACT,         1, "Screen to Front" ),
    HOTKEY_DESCRIPTION( ScreenToBack,          ScreenToBack_ACT,          1, "Screen to Back" ),
    HOTKEY_DESCRIPTION( MoveScreen,            MoveScreen_ACT,            2, "Move Screen" ),
    HOTKEY_DESCRIPTION( ActivateWorkbench,     ActivateWorkbench_ACT,     0, "Activate Workbench" ),
    HOTKEY_DESCRIPTION( BlankDisplay,          BlankDisplay_ACT,          0, "Blank Display" ),
    HOTKEY_DESCRIPTION( InsertText,            InsertText_ACT,            1, "Insert Text" ),
    HOTKEY_DESCRIPTION( InsertDate,            InsertDate_ACT,            1, "Insert Date" ),
    HOTKEY_DESCRIPTION( ShowInterface,         ShowInterface_ACT,         1, "Show Yak Interface" ),
    HOTKEY_DESCRIPTION( CurrentScreenAsDefPub, CurrentScreenAsDefPub_ACT, 0, "Set default public screen" ),
    HOTKEY_DESCRIPTION( MenuShortcut,          MenuShortcut_ACT,          1, "Menu shortcut" ),
    HOTKEY_DESCRIPTION( IconifyWindow,         IconifyWindow_ACT,         1, "Iconify Window" )
};



/* allocate memory region of size len+1, copy string to it */
char *
DupStr(char *str)
{
    char *newstr;
    ULONG len;

    if (newstr = AllocVec(len=(strlen(str)+1),MEMF_CLEAR))
    {
        CopyMem(str,newstr,len);
    }
    return newstr;
}



/*
 * YakOption manipulation routines
 */


#if defined(PREFS) || defined(CONV)
void
DefaultOptions(YakHotKey *yhk)
{
    UWORD ol, optslist;
    OptDescription *curdesc;

    optslist  = YHK_Takes_Opt(yhk);

    for (ol=0; ol<optslist; ol++)
    {
        UWORD as=0;   /* ArgStr number */
        UWORD an=0;   /* ArgNum number */

        curdesc = yhktypes[yhk->yhk_Type].yhkt_OptsList[ol].Desc;

        while (curdesc->Type != NO_OPT)
        {
            yhk->yhk_Option[ol].Flags |= curdesc->DefFlag;

            switch(curdesc->Type)
            {
                case STRING_OPT:
                    if (curdesc->DefFlag)
                        yhk->yhk_Option[ol].ArgStr[as] = DupStr(curdesc->DefArgStr);
                    as++;
                    break;

                case INTEGER_OPT:
                    yhk->yhk_Option[ol].ArgNum[an] = curdesc->DefArgNum;
                    an++;
                    break;
            }

            curdesc++;
        }
    }
}
#endif


/* free ALL memory associated with options */
static void
FreeYakOptions(YakOption *opt, UWORD type)
{
    UWORD ol, optslist=yhktypes[type].yhkt_OptsNum;

    for (ol=0; ol<optslist; ol++)
    {
        OptDescription *curdesc=yhktypes[type].yhkt_OptsList[ol].Desc;
        UWORD as=0;   /* ArgStr number */

        while (curdesc->Type != NO_OPT)
        {
            if (curdesc->Type == STRING_OPT)
                FreeVec(opt[ol].ArgStr[as++]);

            curdesc++;
        }
    
        FreeVec(opt[ol].ArgStr);
        FreeVec(opt[ol].ArgNum);
    }

    FreeVec(opt);
}


static YakOption *
AllocYakOptions(UWORD type)
{
    YakOption *newop;
    UWORD ol, optslist=yhktypes[type].yhkt_OptsNum;

    if (newop=AllocVec(optslist*sizeof(YakOption), MEMF_CLEAR))
    {
        for (ol=0; ol<optslist; ol++)
        {
            OptDescription *curdesc=yhktypes[type].yhkt_OptsList[ol].Desc;
            UWORD as=0;   /* ArgStr number */
            UWORD an=0;   /* ArgNum number */

            while (curdesc->Type != NO_OPT)
            {
                if (curdesc->Type == STRING_OPT)
                    as++;
                if (curdesc->Type == INTEGER_OPT)
                    an++;
                curdesc++;
            }

            if (as)
                                newop[ol].ArgStr = AllocVec(as*sizeof(STRPTR), MEMF_CLEAR);
            if (an)
                                newop[ol].ArgNum = AllocVec(an*sizeof(LONG), MEMF_CLEAR);
        }
    }

    return(newop);
}



/*
 * YakHotKey manipulation routines
 */

static void internal_DeleteYakHotKey(YakHotKey *yhk);

/* free fields of hotkey */
static void
internal_DeleteYakHotKey(YakHotKey *yhk)
{
    if (yhk->yhk_KeyDef)
        FreeVec(yhk->yhk_KeyDef);

    if (yhk->yhk_Name)
        FreeVec(yhk->yhk_Name);

    FreeYakOptions(yhk->yhk_Option, yhk->yhk_Type);

#ifndef PREFS
    if (yhk->yhk_CxObj)
        DeleteCxObjAll(yhk->yhk_CxObj);
#endif
}

/* free ALL memory associated with a hotkey and remove from list */
void
DeleteYakHotKey(YakHotKey *yhk)
{
    Remove((struct Node *)yhk);
    internal_DeleteYakHotKey(yhk);
    FreeVec(yhk);
}

/* create or change key definition 
**
** For prefs program and inactive hotkeys
** we create a CxObj just to test the specification of hot key.
*/
int
ModifyYHKKeyDef(YakHotKey *yhk, char *keystr)
{
#ifndef CONV
    CxObj *filter;
    char  *newdef;

    if (filter = HotKey(keystr, broker_mp, (LONG)yhk))
    {
#ifndef PREFS
        /* delete old filter and use new one */
        if (yhk->yhk_CxObj)
            DeleteCxObjAll(yhk->yhk_CxObj);
        /* Add if active */
        if (yhk->yhk_State == YKHK_ACTIVE)
        {
            yhk->yhk_CxObj = filter;
            AttachCxObj(broker, filter);
        }
#endif

        /* and store new keystr */
        if (newdef = DupStr(keystr))
        {
            FreeVec(yhk->yhk_KeyDef);
            yhk->yhk_KeyDef = newdef;
            return TRUE;
        }
        PostError(getString(Allocation_ERR));
    }
    else PostError("%s:\n\"%s\"", getString(Invalid_hotkey_specif_ERR), keystr);

#else   /* Convert */
        /* and store keystr */
        if (yhk->yhk_KeyDef = DupStr(keystr))
        {
            return TRUE;
        }
        PostError(getString(Allocation_ERR));

#endif

    return FALSE;
}


/* change hotkey name */
int
ModifyYHKName(YakHotKey *yhk, char *namestr)
{
#if defined(PREFS) || defined(CONV)
    if (namestr && *namestr)
    {
        char *newstr;

        if (newstr = DupStr(namestr))
        {
            FreeVec(yhk->yhk_Name);
            yhk->yhk_Name = newstr;
            yhk->yhk_Node.ln_Name = yhk->yhk_Name;
            return TRUE;
        }
        PostError(getString(Allocation_ERR));
    }
    else PostError(getString(Name_unspecified_for_key_ERR));

    return FALSE;
#else
        return TRUE;       /* Yak only! */
#endif
}



/* add a new hotkey of given type */
YakHotKey *
NewYakHotKey(UWORD type)
{
    YakHotKey *newhk;

    if (newhk=AllocVec(sizeof(YakHotKey), MEMF_CLEAR))
    {
        newhk->yhk_Node.ln_Name = "unnamed";
        newhk->yhk_Type         = type;
        
        if (!YHK_Takes_Opt(newhk) || (newhk->yhk_Option=AllocYakOptions(type)))
        {
            AddTail(keylist(type), (struct Node *)newhk);
            return newhk;
        }

        FreeVec(newhk);
    }

    PostError(getString(Allocation_ERR));

    return NULL;
}

/* initialise list */
void
InitYakHotKeyList(void)
{
    UWORD i;

    for (i = 0; i < NUM_HOTKEY_TYPES; i++)
        NewList(keylist(i));
}

/* delete whole list */
void
DeleteYakHotKeyList(void)
{
    YakHotKey *yhk;
    UWORD i;

    for (i = 0; i < NUM_HOTKEY_TYPES; i++)
        while (yhk = (YakHotKey *)RemHead(keylist(i)))
            DeleteYakHotKey(yhk);
}


#ifdef PREFS
/* control hotkey */
APTR
ControlYakHotKey(YakHotKey *yhk)
{
    if (!yhk->yhk_Name)
        return Name_unspecified_for_key_ERR;

    if (!yhk->yhk_KeyDef)
        return Invalid_hotkey_specif_ERR;

    return NULL;    /* All ok */
}
#endif

