/* Prototypes for functions defined in settings.c */
void SetDefaultSettings(void);
void SaveSettings(char *);
void LoadSettings(char *);
BOOL CopyFile(char *source, char *dest);
__regargs BOOL InitPattern(char *newpatstr, PatternData *pdata);

/***** the toggles *****/
typedef struct {
        BOOL    pos;        /* position of toggle (ie. off or on) */
#ifdef PREFS
        UWORD   gadid;      /* index to CheckBox gadget (or object) array */
        UBYTE   winid;      /* index on which window the gadget belongs */
#endif
} ToggleData;

#define NUM_TOGGLES     15
#define OBSOLETE_TOGGLE (-1)
extern ToggleData toggles[NUM_TOGGLES];


/* some aliases for toggles */

#define autopoint       toggles[0].pos  /* sunmouse */
#define keyactivate     toggles[1].pos  /* key over window activates */
#define autopop         toggles[2].pos  /* autopoptofront */
#define rmbactivate     toggles[3].pos  /* RMB activates window */
#define wildstar        toggles[4].pos  /* allow '*' as wildcard */
#define scractivate     toggles[5].pos  /* activate window when shuffling screens */
#define noclick         toggles[6].pos  /* no click on drives */
#define mmbactivate     toggles[7].pos  /* MMB activates window */
#define blackborder     toggles[8].pos  /* black border on all screens (3.0+) */
#define blankmouseonkey toggles[9].pos  /* blank mouse on key pressed */
#define mmbshift        toggles[10].pos /* LMB-MMB acts as Shift LMB */
#define unixdirs        toggles[11].pos /* use '.' and '..' for directories */
#define slashdir        toggles[12].pos /* use '/' instead of ':' for directories */
#define fullworkbench   toggles[13].pos /* remove wb screen title */
#define capshift        toggles[14].pos /* CapShift */

/* Chunk ID */

#define ID_YKCF MAKE_ID('Y','K','C','F')
#define ID_YKHD MAKE_ID('Y','K','H','D')
#define ID_YKHK MAKE_ID('Y','K','H','K')
#define ID_YKDC MAKE_ID('Y','K','D','C')

