#ifndef YAK_H
#define YAK_H

#ifndef LIBRARIES_COMMODITIES_H
#include <libraries/commodities.h>
#endif

/*
#include "fortify.h" 
*/

#define VERSION_CATALOG 20L

#define WORD_ALIGN(ptr) ((ULONG)(ptr + 1) & ~1)

#define MB_NONE         0       /* mouse-blank method */
#define MB_SPRITES      1
#define MB_COPPER       2
#define NUM_MB          3

#define SB_NONE         0       /* screen-blank method */
#define SB_BLACKSCREEN  1
#define SB_DMA          2
#define SB_POWERSAVE    3
#define NUM_SB          4

#define MAX_BLANKSECS   9999
#define MAX_MBLANKSECS  9999

#define MAX_VOLUME      64
#define MAX_AUTOPOINT   5

#define WILDSTARON      ((struct RootNode *)(((struct DosLibrary *)DOSBase)->dl_Root))->rn_Flags |= RNF_WILDSTAR
#define WILDSTAROFF     ((struct RootNode *)(((struct DosLibrary *)DOSBase)->dl_Root))->rn_Flags &= ~RNF_WILDSTAR


/***** the patterns *****/
#define PATLEN 99
typedef struct {
    char patstr[PATLEN+1];
    char *pat;
} PatternData;

#define NUM_PATTERNS 2
extern PatternData patterns[NUM_PATTERNS];

/* indices of patterns */
#define YP_AUTOSCR_PAT  0
#define YP_POPWIN_PAT   1

/* shorthand */
#define autoscrpat      patterns[YP_AUTOSCR_PAT].pat
#define popwinpat       patterns[YP_POPWIN_PAT].pat

/***** other settings *****/

#define NUM_MISCELLANEOUS 5
extern ULONG click_volume;
extern ULONG blanksecs;
extern ULONG mblanksecs;
extern ULONG mouseblank;
extern ULONG screenblank;
extern ULONG autopoint_delay;

#ifdef OLD
extern LONG datefmt;
#endif

extern ULONG blanktimeout;
extern ULONG blankcount;

extern ULONG mblanktimeout;
extern ULONG mblankcount;

extern BOOL  lockblanking;

extern LONG qualifier;

/* changed for 2.00 */
#define CONFIG_FILE        "Yak.prefs"
#define ENV_CONFIG_FILE    "ENV:" CONFIG_FILE
#define ENVARC_CONFIG_FILE "ENVARC:" CONFIG_FILE

/*** private function of "commodities.library" ***/
#pragma libcall CxBase BrokerCommand c6 802
LONG BrokerCommand(char *, LONG id);

#define MIN(a,b) ((a)>(b)?(b):(a))
#define MAX(a,b) ((a)<(b)?(b):(a))

/*** defines from main.c ***/ 
extern struct Locale *locale;
extern CxObj *broker;
extern struct MsgPort *broker_mp;
extern ULONG wndsigflag;
extern char *PopKeyStr;
extern void RegisterSignal(ULONG I_sigflag);

#ifdef DEBUG
#  define DEBUG_PUTSTR(a)    puts(a);
#  define DEBUG_GETCHR       getc();
#  define DEBUG_PRINTF(a,b)  printf(a,b);
#  define DEBUG_BEGIN(a)     printf("Begin of %s \n",a);
#  define DEBUG_END(a)       printf("End of %s \n",a);
   /* for debugging purpose : to locate enforcer hits which don't have hunk numbers */
#  define DO_ENFORCER_HIT {char *x; x = NULL; *x= 0;}
#  define DO_ENFORCER_HIT_VAL(n) {char *x; x = NULL; *x= n;}
#else
#  define DO_ENFORCER_HIT 
#  define DO_ENFORCER_HIT_VAL(n) 
#  define DEBUG_PUTSTR(a)
#  define DEBUG_GETCHR
#  define DEBUG_PRINTF(a,b)
#  define DEBUG_BEGIN(a)
#  define DEBUG_END(a)  
#endif


#endif 
