
#ifndef BLANK_H

#define BLANK_H

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif
#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif

/* Blanking Window gadgets */

#define GDX_ScrTONum        0
#define GDX_MouseTONum      1
#define GDX_MBMethod        2
#define GDX_Return3         3
#define GDX_BlankMouseOnKey 4
#define GDX_ScrBlMethod     5


/* Number of gadgets */

#define Blank_CNT          6



/* Global variables */

#ifdef GADTOOLS
GLOBAL struct Window       *BlankWnd;
GLOBAL struct Gadget       *BlankGList;
GLOBAL struct Gadget       *BlankGadgets[Blank_CNT];
GLOBAL UWORD                BlankWidth;
GLOBAL UWORD                BlankHeight;
GLOBAL UBYTE               *BlankWdt;
GLOBAL struct IntuiText     BlankIText[];
GLOBAL UWORD                BlankGTypes[];
GLOBAL struct NewGadget     BlankNGad[];
GLOBAL ULONG                BlankGTags[];
GLOBAL UBYTE               *MBMethod0Labels[];
#endif

GLOBAL int  OpenBlankWindow     (void);
GLOBAL VOID CloseBlankWindow    (VOID);
GLOBAL LONG HandleBlankIDCMP    (VOID);
GLOBAL BOOL ShowBlankWindow     (VOID);

#ifdef MUI
GLOBAL APTR   BlankWnd;
GLOBAL APTR   BlankObjects[];
GLOBAL UBYTE *BlankWdt;
#endif

#ifdef BGUI                                             /* NMC */
GLOBAL struct Window            *BlankWnd;
GLOBAL Object                   *BlankObjects[];
#endif


#if defined(BGUI) || defined(MUI)              /* NMC */

#define INT_ScrTimeout          BlankObjects[GDX_ScrTONum]
#define INT_MouseTimeout        BlankObjects[GDX_MouseTONum]
#define CYC_MBMethod            BlankObjects[GDX_MBMethod]
#define BT_Return3              BlankObjects[GDX_Return3]
#define CH_BlankMKey            BlankObjects[GDX_BlankMouseOnKey]
#define CYC_SBMethod            BlankObjects[GDX_ScrBlMethod]

GLOBAL APTR CreateBlankWindow   (VOID);
GLOBAL BOOL ShowBlankWindow     (VOID);
GLOBAL VOID CloseBlankWindow    (VOID);
GLOBAL LONG HandleBlankReturnID (LONG id);
#endif

#endif /* BLANK_H */
