
#ifndef DIGITALCLOCK_H

#define DIGITALCLOCK_H

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif
#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif

/* DigitalClocking Window gadgets */

#define GDX_DC_State            0
#define GDX_DC_Offset           1
#define GDX_DC_Interval         2
#define GDX_DC_ShowDate         3
#define GDX_DC_ShowDay          4
#define GDX_DC_ShortDay         5
#define GDX_DC_ShowSecs         6
#define GDX_DC_DateFormat       7
#define GDX_DC_LocaleDateFormat 8
#define GDX_DC_ScreenSelection  9
#define GDX_DC_ScreenPattern    10
#define GDX_DC_OK               11


/* Number of gadgets */

#define DigitalClock_CNT            12



/* Global variables */

#ifdef GADTOOLS
GLOBAL struct Window       *DigitalClockWnd;
GLOBAL struct Gadget       *DigitalClockGList;
GLOBAL struct Gadget       *DigitalClockGadgets[DigitalClock_CNT];
GLOBAL UWORD                DigitalClockWidth;
GLOBAL UWORD                DigitalClockHeight;
GLOBAL UBYTE               *DigitalClockWdt;
GLOBAL struct IntuiText     DigitalClockIText[];
GLOBAL UWORD                DigitalClockGTypes[];
GLOBAL struct NewGadget     DigitalClockNGad[];
GLOBAL ULONG                DigitalClockGTags[];
GLOBAL UBYTE               *DateFormatLabels[];
GLOBAL UBYTE               *ScreenSelectionLabels[];
#endif

GLOBAL int  OpenDigitalClockWindow     (void);
GLOBAL VOID CloseDigitalClockWindow    (VOID);
GLOBAL LONG HandleDigitalClockIDCMP    (VOID);
GLOBAL BOOL ShowDigitalClockWindow     (VOID);

#ifdef MUI
GLOBAL APTR   DigitalClockWnd;
GLOBAL APTR   DigitalClockObjects[];
GLOBAL UBYTE *DigitalClockWdt;
#endif

#ifdef BGUI                                             /* NMC */
GLOBAL struct Window            *DigitalClockWnd;
GLOBAL Object                   *DigitalClockObjects[];
#endif

#if defined(BGUI) || defined(MUI)              /* NMC */

#define CH_DC_State             DigitalClockObjects[GDX_DC_State]
#define INT_DC_Offset           DigitalClockObjects[GDX_DC_Offset]
#define INT_DC_Interval         DigitalClockObjects[GDX_DC_Interval]
#define CH_DC_ShowDate          DigitalClockObjects[GDX_DC_ShowDate]
#define CH_DC_ShowDay           DigitalClockObjects[GDX_DC_ShowDay]
#define CH_DC_ShortDay          DigitalClockObjects[GDX_DC_ShortDay]
#define CH_DC_ShowSecs          DigitalClockObjects[GDX_DC_ShowSecs]
#define CYC_DC_DateFormat       DigitalClockObjects[GDX_DC_DateFormat]
#define STR_DC_LocaleDateFormat DigitalClockObjects[GDX_DC_LocaleDateFormat]
#define CYC_DC_ScreenSelection  DigitalClockObjects[GDX_DC_ScreenSelection]
#define STR_DC_ScreenPattern    DigitalClockObjects[GDX_DC_ScreenPattern]
#define BT_DC_OK                DigitalClockObjects[GDX_DC_OK]

GLOBAL APTR CreateDigitalClockWindow   (VOID);
GLOBAL BOOL ShowDigitalClockWindow     (VOID);
GLOBAL VOID CloseDigitalClockWindow    (VOID);
GLOBAL LONG HandleDigitalClockReturnID (LONG id);
#endif

#endif /* DIGITALCLOCK_H */
