
#ifndef HOTKEY_H

#define HOTKEY_H

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif
#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif

/* HotKeys Window gadgets */

#define GDX_Actions        0
#define GDX_Hotkeys        1
#define GDX_Add            2
#define GDX_Delete         3
#define GDX_State          4
#define GDX_Return         5
#define GDX_Name           6
#define GDX_Definition     7
#define GDX_Options        8


/* Number of gadgets  */

#define HotKey_CNT         9


/* Global variables */

#ifdef GADTOOLS
GLOBAL struct Window       *HotKeyWnd;
GLOBAL struct Gadget       *HotKeyGList;
GLOBAL struct Gadget       *HotKeyGadgets[HotKey_CNT];
GLOBAL UWORD                HotKeyWidth;
GLOBAL UWORD                HotKeyHeight;
GLOBAL UBYTE               *HotKeyWdt;
GLOBAL UWORD                HotKeyGTypes[];
GLOBAL struct NewGadget     HotKeyNGad[];
GLOBAL ULONG                HotKeyGTags[];
#endif

GLOBAL struct MinList       Actions1List;
GLOBAL struct Node          Actions1Nodes[];


/* Global prototypes */

GLOBAL VOID InitState1Labels  (VOID);
GLOBAL void InitActionsList   (void);
GLOBAL VOID HotKeyRender      (VOID);
GLOBAL int  OpenHotKeyWindow  (VOID);
GLOBAL VOID CloseHotKeyWindow (VOID);
GLOBAL LONG HandleHotKeyIDCMP (VOID);
GLOBAL BOOL ShowHotKeyWindow  (VOID);


#ifdef MUI
GLOBAL APTR   HotKeyWnd;
GLOBAL APTR   HotKeyObjects[];
GLOBAL UBYTE *HotKeyWdt;
#endif

#ifdef BGUI                     /* NMC */
GLOBAL struct Window            *HotKeyWnd;
GLOBAL Object                   *HotKeyObjects[];
#endif


#if defined(MUI) || defined(BGUI)               /* NMC */

#define LV_Actions               HotKeyObjects[GDX_Actions]
#define LV_HotKeys               HotKeyObjects[GDX_Hotkeys]
#define BT_Add                   HotKeyObjects[GDX_Add]
#define BT_Delete                HotKeyObjects[GDX_Delete]
#define CY_State                 HotKeyObjects[GDX_State]      /* MUI  */
#define CH_State                 HotKeyObjects[GDX_State]      /* BGUI */
#define BT_Return                HotKeyObjects[GDX_Return]
#define STR_Name                 HotKeyObjects[GDX_Name]
#define BT_Definition            HotKeyObjects[GDX_Definition]
#define BT_Options               HotKeyObjects[GDX_Options]

GLOBAL APTR CreateHotKeyWindow   (VOID);
GLOBAL BOOL ShowHotKeyWindow     (VOID);
GLOBAL VOID CloseHotKeyWindow    (VOID);
GLOBAL LONG HandleHotKeyReturnID (LONG id);
#endif /* BGUI */

#endif /* HOTKEY_H */
