
#ifndef KEYDEFWIN_H

#define KEYDEFWIN_H

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif
#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif


/* KeyDef window gadgets */

#define GDX_Class            0
#define GDX_Stroke           1
#define GDX_Desc             2
#define GDX_Ok               3
#define GDX_Cancel           4
#define GDX_Clear            5
#define GDX_Help             6

/* Number of gadgets */

#define KeyDef_CNT         7



/* Global variables */

#ifdef GADTOOLS
GLOBAL struct Window        *KeyDefWnd;
GLOBAL struct Gadget        *KeyDefGList;
GLOBAL struct Gadget        *KeyDefGadgets[KeyDef_CNT];
GLOBAL UWORD                 KeyDefWidth;
GLOBAL UWORD                 KeyDefHeight;
GLOBAL UBYTE                *KeyDefWdt;
GLOBAL UWORD                 KeyDefGTypes[];
GLOBAL struct NewGadget      KeyDefNGad[];
GLOBAL ULONG                 KeyDefGTags[];
#endif

GLOBAL UBYTE                *Class0Labels[];
GLOBAL UBYTE                *Stroke0Labels[];


/* Exported functions */

GLOBAL VOID InitClass0Labels  (VOID);
GLOBAL VOID InitStroke0Labels (VOID);
GLOBAL BOOL SwitchToKeyDefWindow (UBYTE I_ParentWindowID, APTR I_object, char *I_action);
GLOBAL LONG HandleKeyDefIDCMP (VOID);
GLOBAL VOID CloseKeyDefWindow (VOID);
GLOBAL VOID KeyDefRender      (VOID);
GLOBAL int  OpenKeyDefWindow  (VOID);
GLOBAL BOOL ShowKeyDefWindow  (VOID);


#ifdef MUI
GLOBAL APTR              KeyDefWnd;
GLOBAL APTR              KeyDefObjects[];
GLOBAL UBYTE            *KeyDefWdt;
#endif

#ifdef BGUI                     /* NMC */
GLOBAL struct Window    *KeyDefWnd;
GLOBAL Object           *KeyDefObjects[];
#endif

#if defined(MUI) || defined(BGUI)               /* NMC */
#define CYC_Class               KeyDefObjects[GDX_Class]
#define CYC_Stroke              KeyDefObjects[GDX_Stroke]
#define STR_Desc                KeyDefObjects[GDX_Desc]
#define BT_Ok                   KeyDefObjects[GDX_Ok]
#define BT_Cancel2              KeyDefObjects[GDX_Cancel]
#define BT_Clear                KeyDefObjects[GDX_Clear]
#define BT_Help                 KeyDefObjects[GDX_Help]

GLOBAL APTR CreateKeyDefWindow   (VOID);
GLOBAL BOOL ShowKeyDefWindow     (VOID);
GLOBAL VOID CloseKeyDefWindow    (VOID);
GLOBAL LONG HandleKeyDefReturnID (LONG id);

#endif /* MUI or BGUI */

#endif /* KEYDEFWIN_H */
