
#ifndef MISC_H

#define MISC_H

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif
#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif

/* Miscellaneous Window gadgets */

#define GDX_ClickVol             0
#define GDX_Return2              1
#define GDX_BlackBorderCheck     2
#define GDX_WildStarCheck        3
#define GDX_NoClickCheck         4
#define GDX_UnixDirsCheck        5
#define GDX_MMBShiftCheck        6
#define GDX_SlashDirCheck        7
#define GDX_FullWorkbenchCheck   8
#define GDX_CapShiftCheck        9

/* Number of gadgets */

#define Misc_CNT                 10


/* Global variables */

#ifdef GADTOOLS
GLOBAL struct Window       *MiscWnd;
GLOBAL struct Gadget       *MiscGList;
GLOBAL struct Gadget       *MiscGadgets[Misc_CNT];
GLOBAL UWORD                MiscWidth;
GLOBAL UWORD                MiscHeight;
GLOBAL UBYTE               *MiscWdt;
GLOBAL UWORD                MiscGTypes[];
GLOBAL struct NewGadget     MiscNGad[];
GLOBAL ULONG                MiscGTags[];
#endif

/* Global prototypes */

GLOBAL VOID MiscRender      (VOID);
GLOBAL int OpenMiscWindow   (VOID);
GLOBAL VOID CloseMiscWindow (VOID);
GLOBAL LONG HandleMiscIDCMP (VOID);
GLOBAL BOOL ShowMiscWindow  (VOID);

#ifdef BGUI                                             /* NMC */
GLOBAL struct Window           *MiscWnd;
GLOBAL Object                  *MiscObjects[];
#endif

#ifdef MUI
GLOBAL APTR        *MiscWnd;
GLOBAL APTR         MiscObjects[];
#endif

#if defined(MUI) || defined(BGUI)               /* NMC */

#define SL_ClickVol             MiscObjects[GDX_ClickVol]
#define BT_Return2              MiscObjects[GDX_Return2]
#define CH_BlackBorder          MiscObjects[GDX_BlackBorderCheck]
#define CH_WildStar             MiscObjects[GDX_WildStarCheck]
#define CH_NoClick              MiscObjects[GDX_NoClickCheck]
#define CH_UnixDirs             MiscObjects[GDX_UnixDirsCheck]
#define CH_MMBShift             MiscObjects[GDX_MMBShiftCheck]
#define CH_SlashDir             MiscObjects[GDX_SlashDirCheck]
#define CH_FullWorkbench        MiscObjects[GDX_FullWorkbenchCheck]
#define CH_CapShift             MiscObjects[GDX_CapShiftCheck]

GLOBAL APTR CreateMiscWindow   (VOID);
GLOBAL BOOL ShowMiscWindow     (VOID);
GLOBAL VOID CloseMiscWindow    (VOID);
GLOBAL LONG HandleMiscReturnID (LONG id);
#endif /* BGUI */

#endif /* MISC_H */
