
#ifndef MOUSECYCLING_H

#define MOUSECYCLING_H

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif
#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif


#define GDX_WindowToFrontActive                0
#define GDX_WindowToBackActive                 1
#define GDX_ScreenCyclingActive                2
#define GDX_ScreenToFront_Check                3
#define GDX_ScreenToBack_Check                 4
#define GDX_WindowToFrontClicks                5
#define GDX_ExcludeWbWindow                    6
#define GDX_WindowToFrontPattern               7
#define GDX_WindowToBackPattern                8
#define GDX_ScreenCyclingPattern               9
#define GDX_HotkeyScreenCycling                10
#define GDX_HotkeyWindowToBack                 11
#define GDX_HotkeyWindowToFront                12
#define GDX_WindowToBackClicks                 13
#define GDX_ScreenCyclingClicks                14
#define GDX_Return5                            15

#define MouseCycling_CNT 16

#ifdef GADTOOLS
extern struct Window        *MouseCyclingWnd;
extern struct Gadget        *MouseCyclingGList;
extern struct Gadget        *MouseCyclingGadgets[MouseCycling_CNT];
extern UWORD                 MouseCyclingWidth;
extern UWORD                 MouseCyclingHeight;
extern UBYTE                *MouseCyclingWdt;
extern struct IntuiText      MouseCyclingIText[];
extern UWORD                 MouseCyclingGTypes[];
extern struct NewGadget      MouseCyclingNGad[];
extern ULONG                 MouseCyclingGTags[];
#endif

GLOBAL VOID InitClick1Labels        (VOID);
GLOBAL VOID InitMouseCyclingITexts  (VOID);
GLOBAL VOID MouseCyclingRender      (VOID);
GLOBAL int  OpenMouseCyclingWindow  (VOID);
GLOBAL VOID CloseMouseCyclingWindow (VOID);
GLOBAL LONG HandleMouseCyclingIDCMP (VOID);
GLOBAL BOOL ShowMouseCyclingWindow  (VOID);

#ifdef BGUI                                             /* NMC */
GLOBAL struct Window  *MouseCyclingWnd;
GLOBAL Object         *MouseCyclingObjects[];
#endif

#ifdef MUI
GLOBAL APTR           *MouseCyclingWnd;
GLOBAL APTR            MouseCyclingObjects[];
#endif

#if defined(MUI) || defined(BGUI)               /* NMC */

#define CH_WinToFrontActive             MouseCyclingObjects[GDX_WindowToFrontActive]
#define CH_WinToBackActive              MouseCyclingObjects[GDX_WindowToBackActive]
#define CH_ScrCyclingActive             MouseCyclingObjects[GDX_ScreenCyclingActive]
#define CH_ScrToFront                   MouseCyclingObjects[GDX_ScreenToFront_Check]
#define CH_ScrToBack                    MouseCyclingObjects[GDX_ScreenToBack_Check]
#define CH_ExcludeWBWin                 MouseCyclingObjects[GDX_ExcludeWbWindow]
#define STR_WinToFrontPat               MouseCyclingObjects[GDX_WindowToFrontPattern]
#define STR_WinToBackPat                MouseCyclingObjects[GDX_WindowToBackPattern]
#define STR_ScrCyclingPat               MouseCyclingObjects[GDX_ScreenCyclingPattern]
#define BT_HotkeyScrCycling             MouseCyclingObjects[GDX_HotkeyScreenCycling]
#define BT_HotkeyWinToBack              MouseCyclingObjects[GDX_HotkeyWindowToBack]
#define BT_HotkeyWinToFront             MouseCyclingObjects[GDX_HotkeyWindowToFront]
#define CYC_WinToFrontClicks            MouseCyclingObjects[GDX_WindowToFrontClicks]
#define CYC_WinToBackClicks             MouseCyclingObjects[GDX_WindowToBackClicks]
#define CYC_ScrCyclingClicks            MouseCyclingObjects[GDX_ScreenCyclingClicks]
#define BT_Return5                      MouseCyclingObjects[GDX_Return5]

GLOBAL APTR CreateMouseCyclingWindow   (VOID);
GLOBAL BOOL ShowMouseCyclingWindow     (VOID);
GLOBAL VOID CloseMouseCyclingWindow    (VOID);
GLOBAL LONG HandleMouseCyclingReturnID (LONG id);
#endif /* BGUI */

#endif   /* MOUSECYCLING_H */
