#ifndef HOTKEY_OPTIONS_H
#define HOTKEY_OPTIONS_H

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif
#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif

#include "hotkey_types.h"



/* Blanking Window gadgets */

#define GDX_Page_Opts      0
#define GDX_OK_Opts        1
#define GDX_Default_Opts   2
#define GDX_Cancel_Opts    3


/* Number of gadgets */

#define Options_CNT  4

#ifdef GADTOOLS
GLOBAL struct Window       *OptionsWnd;
GLOBAL struct Gadget       *OptionsGList;
GLOBAL struct NewGadget     OptionsNGad[];
GLOBAL struct Gadget       *OptionsGadgets[Options_CNT];
GLOBAL UWORD                OptionsWidth;
GLOBAL UWORD                OptionsHeight;
GLOBAL UBYTE               *OptionsWdt;
#endif

GLOBAL VOID GetYakOption          (VOID);
GLOBAL VOID InitOptionsGadgets    (VOID);
GLOBAL VOID OptionsRender         (VOID);
GLOBAL int  OpenOptionsWindow     (VOID);
GLOBAL VOID CloseOptionsWindow    (VOID);
GLOBAL LONG HandleOptionsIDCMP    (VOID);
GLOBAL BOOL ShowOptionsWindow     (VOID);
GLOBAL BOOL SwitchToOptionsWindow (VOID);


struct GadgetData
{
#ifdef GADTOOLS
    UWORD  gd_LeftEdge, gd_TopEdge;      /* gadget position */
    UWORD  gd_Width,    gd_Height;       /* gadget size */
    struct TagItem *gd_Tags;             /* gadget tags */
#endif

    STRPTR gd_Text;                      /* gadget text */
    UWORD  gd_Type;                      /* gadget type */
    ULONG  gd_Flags;                     /* gadget flags */
    UWORD  gd_ReturnID;                  /* gadget userdata */

    APTR   gd_Gadget;                    /* GADTOOLS, BGUI or MUI object */
    BOOL   gd_Disabled;

    UWORD  gd_ListID;
    OptDescription *gd_Desc;

    UWORD  gd_Flag;
    STRPTR gd_ArgStr;
    LONG   gd_ArgNum;
};

#ifdef BGUI                     /* NMC */
GLOBAL struct Window            *OptionsWnd;
GLOBAL Object                           *OptionsObjects[];
#endif

#if defined(MUI) || defined(BGUI)               /* NMC */

#define MX_Page                         OptionsObjects[GDX_Page_Opts]
#define BT_OK_Opts                      OptionsObjects[GDX_OK_Opts]
#define BT_Default_Opts                 OptionsObjects[GDX_Default_Opts]
#define BT_Cancel_Opts                  OptionsObjects[GDX_Cancel_Opts]

GLOBAL APTR CreateOptionsWindow   (VOID);
GLOBAL BOOL ShowOptionsWindow     (VOID);
GLOBAL VOID CloseOptionsWindow    (VOID);
GLOBAL LONG HandleOptionsReturnID (LONG id);

#endif /* MUI or BGUI */

#endif    /* HOTKEY_OPTIONS_H */
