
#ifndef ROOT_H

#define ROOT_H

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif
#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif

#define GDX_AutoCheck                          0
#define GDX_KeyActCheck                        1
#define GDX_ScrActCheck                        2
#define GDX_AutoPopCheck                       3
#define GDX_RMBActCheck                        4
#define GDX_MMBActCheck                        5
#define GDX_AutoPat                            6
#define GDX_PopPat                             7
#define GDX_EditHotkeys                        8
#define GDX_Miscellaneous                      9
#define GDX_Blanking                           10
#define GDX_Save                               11
#define GDX_Cancel0                            12
#define GDX_Use                                13
#define GDX_MouseCycling                       14
#define GDX_AutoPointDelay                     15
#define GDX_DigitalClock                       16

/* Number of gadgets of root window */

#define Root_CNT          17

#define  MDX_PROJECT     0
#define  MDX_OPEN        1
#define  MDX_SAVE        2
#define  MDX_SAVEAS      3
#define  MDX_ABOUT       5
#define  MDX_HIDE        7
#define  MDX_QUIT        8
#define  MDX_EDIT        9
#define  MDX_DEFAULT     10
#define  MDX_LASTSAVED   11
#define  MDX_ACTIVE      12
#define  MDX_OPTIONS     13
#define  MDX_CREATEICONS 14


/* Global variables */

#ifdef GADTOOLS
GLOBAL struct Window       *RootWnd;
GLOBAL struct Gadget       *RootGList;
GLOBAL struct Menu         *RootMenus;
GLOBAL struct Gadget       *RootGadgets[];
GLOBAL UWORD                RootWidth;
GLOBAL UWORD                RootHeight;
GLOBAL UBYTE               *RootWdt;
GLOBAL struct IntuiText     RootIText[];
GLOBAL struct NewMenu       RootNewMenu[];
GLOBAL struct NewGadget     RootNGad[];
GLOBAL ULONG                RootGTags[];
#endif


/* Exported functions */

GLOBAL VOID InitRootITexts       (VOID);
GLOBAL VOID RootRender           (VOID);
GLOBAL int  OpenRootWindow       (VOID);
GLOBAL VOID CloseRootWindow      (VOID);
GLOBAL BOOL ShowRootWindow       (VOID);
GLOBAL LONG HandleRootIDCMP      (VOID);
GLOBAL BOOL SwitchFromRootWindow (UBYTE WindowID);

#ifdef MUI
GLOBAL APTR   RootWnd;
GLOBAL APTR   RootObjects[];
GLOBAL UBYTE *RootWdt;
#endif

#ifdef BGUI                     /* NMC */
GLOBAL struct Window  *RootWnd;
GLOBAL Object         *RootObjects[];
GLOBAL UBYTE          *RootWdt;
GLOBAL struct NewMenu  RootNewMenu[];
#endif

#if defined(MUI) || defined(BGUI)               /* NMC */
#define    CH_KeyActivate       RootObjects[GDX_KeyActCheck]
#define    CH_MMBActivate       RootObjects[GDX_MMBActCheck]
#define    CH_RMBActivate       RootObjects[GDX_RMBActCheck]
#define    CH_AutoPoint         RootObjects[GDX_AutoCheck]
#define    STR_AutoScreen       RootObjects[GDX_AutoPat]
#define    SL_AutoPointDelay    RootObjects[GDX_AutoPointDelay]
#define    CH_ScreensActivation RootObjects[GDX_ScrActCheck]
#define    CH_AutoPopToFront    RootObjects[GDX_AutoPopCheck]
#define    STR_PopWindows       RootObjects[GDX_PopPat]
#define    BT_MouseCycling      RootObjects[GDX_MouseCycling]
#define    BT_Blanking          RootObjects[GDX_Blanking]
#define    BT_EditHotkeys       RootObjects[GDX_EditHotkeys]
#define    BT_Miscellaneous     RootObjects[GDX_Miscellaneous]
#define    BT_DigitalClock      RootObjects[GDX_DigitalClock]
#define    BT_Save              RootObjects[GDX_Save]
#define    BT_Use               RootObjects[GDX_Use]
#define    BT_Cancel            RootObjects[GDX_Cancel0]

GLOBAL APTR CreateRootWindow   (VOID);
GLOBAL BOOL ShowRootWindow     (VOID);
GLOBAL VOID CloseRootWindow    (VOID);
GLOBAL LONG HandleRootReturnID (LONG id);

#endif /* MUI or BGUI */

#endif /* ROOT_H */

