
#ifndef GUI_H

#define GUI_H

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef GRAPHICS_TEXT_H
#include <graphics/text.h>
#endif


#define GetString(g) (((struct StringInfo *)g->SpecialInfo)->Buffer )
#define GetNumber(g) (((struct StringInfo *)g->SpecialInfo)->LongInt)

#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

GLOBAL struct Window    *curwin;
GLOBAL UBYTE             curwinID;
GLOBAL WORD              WindowTop;
GLOBAL WORD              WindowLeft;

#ifdef BGUI             /* NMC */
#include <intuition/classes.h>

GLOBAL Object           *curwinobj;
GLOBAL struct TextAttr   Attr;
GLOBAL struct TextFont  *TextFont;
GLOBAL UBYTE            *PubScreenName;
GLOBAL ULONG             appwinsigflag;
#endif

#ifdef MUI
GLOBAL APTR             *curwinobj;
#endif

/* Windows identifiers */

#define NO_WINDOW               0
#define ROOT_WINDOW             1
#define HOTKEY_WINDOW           2
#define MISC_WINDOW             3
#define BLANK_WINDOW            4
#define KEYDEF_WINDOW           5
#define MCYCLING_WINDOW         6
#define OPTIONS_WINDOW          7
#define DIGITALCLOCK_WINDOW     8

enum ids
{
         DUMMY,

         ID_HIDE,           /* MUI */
         ID_SHOW,           /* MUI */

         GD_AutoCheck,
         GD_KeyActCheck,
         GD_ScrActCheck,
         GD_AutoPopCheck,
         GD_RMBActCheck,
         GD_MMBActCheck,
         GD_AutoPat,
         GD_PopPat,
         GD_EditHotkeys,
         GD_Miscellaneous,
         GD_Blanking,
         GD_Save,
         GD_Cancel0,
         GD_Use,
         GD_MouseCycling,
         GD_AutoPointDelay,
         MD_PROJECT,
         MD_OPEN,
         MD_SAVE,
         MD_SAVEAS,
         MD_ABOUT,
         MD_HIDE,
         MD_QUIT,
         MD_EDIT,
         MD_DEFAULT,
         MD_LASTSAVED,
         MD_ACTIVE,
         MD_OPTIONS,
         MD_CREATEICONS,
         GD_DigitalClock,

         GD_Actions,
         GD_Hotkeys,
         GD_Add,
         GD_Delete,
         GD_State,
         GD_Return,
         GD_Name,
         GD_Definition,
         GD_Options,

         GD_ClickVol,
         GD_Return2,
         GD_BlackBorderCheck,
         GD_WildStarCheck,
         GD_NoClickCheck,
         GD_UnixDirsCheck,
         GD_MMBShiftCheck,
         GD_SlashDirCheck,
         GD_FullWorkbenchCheck,
         GD_CapShiftCheck,

         GD_ScrTONum,
         GD_MouseTONum,
         GD_MBMethod,
         GD_Return3,
         GD_BlankMouseOnKey,
         GD_ScrBlMethod,

         GD_Class,
         GD_Stroke,
         GD_Desc,
         GD_Ok,
         GD_Clear,
         GD_Help,
         GD_Cancel,

         GD_Page_MCycling,
         GD_WindowToFrontActive,
         GD_WindowToBackActive,
         GD_ScreenCyclingActive,
         GD_ScreenToFront_Check,
         GD_ScreenToBack_Check,
         GD_WindowToFrontClicks,
         GD_ExcludeWbWindow,
         GD_WindowToFrontPattern,
         GD_WindowToBackPattern,
         GD_ScreenCyclingPattern,
         GD_HotkeyScreenCycling,
         GD_HotkeyWindowToBack,
         GD_HotkeyWindowToFront,
         GD_WindowToBackClicks,
         GD_ScreenCyclingClicks,
         GD_Return5,

         GD_Page_Opts,
         GD_OK_Opts,
         GD_Default_Opts,
         GD_Cancel_Opts,
         GD_FirstOption,

         GD_DC_State,
		 GD_DC_Offset,
		 GD_DC_Interval,
		 GD_DC_ShowDate,
		 GD_DC_ShowDay,
		 GD_DC_ShortDay,
         GD_DC_ShowSecs,
		 GD_DC_DateFormat,
		 GD_DC_LocaleDateFormat,
		 GD_DC_ScreenSelection,
		 GD_DC_ScreenPattern, 
		 GD_DC_OK
};


/***  ***/
#define RET_ERROR      0
#define RET_OKAY       1
#define RET_QUIT       2


#ifdef GADTOOLS

GLOBAL struct Library      *GadToolsBase;
GLOBAL struct Screen       *Scr;
GLOBAL UBYTE               *PubScreenName;
GLOBAL APTR                 VisualInfo;
GLOBAL struct TextAttr     *Font, Attr;
GLOBAL UWORD                FontX, FontY;
GLOBAL UWORD                OffX, OffY;


#ifndef GTMN_NewLookMenus
#define GTMN_NewLookMenus GT_TagBase+67
#endif

#ifndef WA_NewLookMenus
#define WA_NewLookMenus WA_Dummy+0x30
#endif



/* Functions prototypes */

int SetupScreen (VOID);
VOID CloseDownScreen (VOID);
UWORD ComputeX (UWORD value);
UWORD ComputeY (UWORD value);
VOID UseTopaz (VOID);
UWORD CalcFontX (struct TextFont *TFont);
VOID ComputeFont (UWORD width,UWORD height);
__regargs VOID DrawThinBevelBox (struct Screen *Screen, struct RastPort *rp, long Left, long Top, long Width, long Height, BOOL Recess);
__regargs VOID SetUpWindowCoordinates ( UWORD Width, UWORD Height, WORD *Left, WORD *Top);


#endif

/* Shared Prototypes */

GLOBAL __regargs VOID InitWindowGadget (UWORD num, LONG tagtype, LONG tagvalue, UBYTE WindowID);
GLOBAL __regargs VOID InitToggleGadgets ( UBYTE WindowID );
GLOBAL __regargs VOID NewPattern (UWORD gdx, PatternData *pdata, struct Gadget *gad, UBYTE WindowID);
GLOBAL __regargs void LocalizeNGadLabels (UBYTE Gadgets_Num, struct NewGadget *NGad);
GLOBAL VOID DisableYakInterface (VOID);
GLOBAL VOID EnableYakInterface (VOID);
GLOBAL BOOL ShowYakInterface (VOID);
GLOBAL BOOL ShowWindowID (UBYTE WindowID);
GLOBAL VOID CloseWindowID (UBYTE WindowID);
GLOBAL VOID CloseOneWindow  (struct Window *Wnd, struct Menu *Menus, struct Gadget *GList, struct AppWindow *AppWin);
GLOBAL VOID HideInterface (VOID);

/* Prototypes for functions defined in Root_Menus.c */
GLOBAL VOID InitRootNewMenu (VOID);

#endif /* GUI_H */
