
#ifndef KEYDEF_H

#define KEYDEF_H

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef DEVICES_INPUTEVENT_H
#include <devices/inputevent.h>
#endif


/*
 * YakKeyDef structure definition
 */
typedef struct {
    LONG  ykd_Class;
    UWORD ykd_Qual;
    UWORD ykd_IQual;
    UWORD ykd_SQual;
    LONG  ykd_Stroke;
    UWORD ykd_Code;
} YakKeyDef;



#define HKCLASS_RAWKEY       0
#define HKCLASS_RAWMOUSE     1
#define HKCLASS_DISKINSERTED 2
#define HKCLASS_DISKREMOVED  3

#define HKSTROKE_DOWN    0
#define HKSTROKE_UP      1
#define HKSTROKE_DOWN_UP 2

#define IEQUALIFIER_MOUSEBUTTONS (IEQUALIFIER_MIDBUTTON|IEQUALIFIER_RBUTTON|IEQUALIFIER_LEFTBUTTON)
#define IEQUALIFIER_KEYS         (IEQUALIFIER_NUMERICPAD|IEQUALIFIER_REPEAT)
#define NO_IEQUALIFIER 0x0000


struct QualifierArrayType
{
    UWORD  qat_ID;
    STRPTR qat_Str;
};


struct QualifierPadArrayType
{
    UWORD qpat_Code;
    UWORD qpat_Qualifier;
};


#define NO_IECODE      0xFFFF

struct CodeArrayType
{
    UWORD  cat_Code;
    STRPTR cat_Str;
};


GLOBAL const STRPTR ClassArray[];
GLOBAL const STRPTR StrokeArray[];


GLOBAL __regargs BOOL BuildKeyDef(YakKeyDef *ykd, STRPTR desc);
GLOBAL __regargs LONG ParseKeyDef(STRPTR desc, YakKeyDef *ykd);
GLOBAL __regargs UWORD IsQualifierPad(UWORD code);

#endif /* KEYDEF_H */

