/* The following lists manipulation functions are not needed for DICE
 * because they are already implemented in DICE c.lib 
 */

#include <exec/lists.h>
#include "sas_lists.h"

void *GetHead(const struct MinList *List)
{
        struct MinNode *Head = List->mlh_Head;
        return (Head->mln_Succ) ? Head : NULL;
}


void *GetSucc(const struct MinNode *Node)
{
        struct MinNode *Succ = Node->mln_Succ;
        return (Succ->mln_Succ) ? Succ : NULL;
}


void *GetTail(const struct MinList *List)
{
        struct MinNode *TailPred = List->mlh_TailPred;
        return (TailPred->mln_Pred) ? TailPred : NULL;
}


void *GetPred(const struct MinNode *Node)
{
        struct MinNode *Pred = Node->mln_Pred;
        return (Pred->mln_Pred) ? Pred : NULL;
}
