/* Exported functions */

#ifndef PREFS
extern int DC_F_Init(void);

extern void DC_F_DisableClock(void);

extern void DC_F_EnableClock(void);

extern void DC_F_ProcessMsg(long sig);

extern void DC_F_CleanUp(void);
#endif

extern void DC_F_Set_Default(void);

#ifndef CONV
extern APTR ReadDigitalClock(UBYTE *chunkbuf, ULONG size);
#endif

#if defined(PREFS) || defined(CONV)
APTR WriteDigitalClock(struct IFFHandle *iff, UBYTE *chunkbuf);
#endif
/* Data structures */

#ifndef PREFS
extern ULONG DC_V_TimerSig;
#endif

typedef enum 
{
    DC_C_WorkbenchScreen = 0,
    DC_C_FrontScreen = 1,
    DC_C_FrontPubScreen = 2,
    DC_C_DefPubScreen = 3,
    DC_C_ScreensByPattern = 4
} DC_T_ScreenSelection;

typedef enum 
{
    DC_C_FormatDos = FORMAT_DOS,
    DC_C_FormatInt = FORMAT_INT,
    DC_C_FormatUsa = FORMAT_USA,
    DC_C_FormatCdn = FORMAT_CDN,
    DC_C_LocaleDateFormat
} DC_T_DateFormat;


#define DC_C_UNACTIVE 0
#define DC_C_ACTIVE   1


typedef struct DC_S_Config
{
    UWORD State;        /* clock state, 0 = not active            */
    UWORD Offset;       /* Number of pixels between screen depth gadget and clock text */
    LONG Interval;      /* Number of seconds between 2 clock updates */
    UWORD ShowDate;     /* Show date in addition to the current time */
    UWORD ShowDay;      /* Show day in addition to the current time  */
    UWORD ShortDay;     /* Day name will be truncated to the 3 first characters */
    UWORD ShowSecs;     /* Display seconds as well as hours and minutes */
    DC_T_DateFormat DateFormat;  /* Set the format of the date display */
    char *LocaleDateFormat;   /* Set the format of the date using locale library */
    DC_T_ScreenSelection ScreenSelection; /* Display clock only on public screens */
    PatternData ScreenPatternData; /* Screens where the clock is allowed */
	UWORD TimerRunning;
} DC_T_Config;


/* Current configuration of the clock */

extern DC_T_Config DC_V_Config;

